unit ErrorsAndBeeps;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-2002 Universiteit Utrecht, FRW, Vakgroep Kartografie &   
{     International Institute for Aerospace Survey And Earth Sciences ITC 
{ 	Version 2.0     -  Changes programmed by B.J. Kbben, 1992  
{ 	 Version 2.2  - Warning now transfered here from unit myWindows			
									  & included LineNr in warnings (9/96)
									- Installed memory cushion in Function MemAvail, 
										in order not to crash whem memory is low, just exitToShell
									- MAJOR CHANGE IN MEMEORY ERROR MANAGMENT:
										New routine MemAvail checks for memory pool (with mem cushion) 
										to exitToshell without crashing 
		Version 2.2OS - code and app made OpenSource July 2002 BJK
{
{ ########################################################}

interface

	uses
	{Macintosh Toolbox interfaces}
	Types, Devices,Events, Dialogs, Menus, Fonts,QDOffscreen,Windows,Controls,
	Quickdraw, Resources,Sound,TextUtils,Toolutils,memory,OSUtils,Processes,MixedMode,
	
	{myUnits}
	Globals;
	
var
	timedDialogUPP: UniversalProcPtr;
	timedDialogStartTime:longint;
		
	procedure InittimedDialog;
	procedure ReportMem;
	FUNCTION MemAvail (memRequest: LongInt): Boolean;
	procedure Play (WhichSound: integer);
	procedure FatOkBox (Dialog: DialogPtr);
	procedure InitError;
	procedure Error (varstring: str255; str1Nr, LineNr: longint; logIt,MemError: boolean);
	procedure Warning (Message: str255; LineNr: longint; sayWarning:boolean);
	function GetARes (resType: OSType; resID: Integer): Handle;

implementation

	procedure writeLog (message: str80);
		external;
	function writelnstring (fileno: integer; str: string): boolean;
		external;
	PROCEDURE CopyToGWorld (wp: WindowPtr);
		external;
	PROCEDURE CopyFromGWorld (wp: WindowPtr);
		external;
	function closeLog: boolean;
		external;
		
var
	errorstring, MemoryErrorstring:str255;
	alreadyHadMemError:boolean;

	
	{--------------------------------------------------------------------------}
	FUNCTION timedDialog(theDialog: DialogPtr; var theEvent:EventRecord; var TheItem:integer): Boolean;
		
		{----------------}
		procedure ChooseDefault;
				const 
				DefaultItem = 1;
				kVisualdelay = 6; 
			var 
				myType: integer;
				myHand: Handle;
				myRect: rect;
				Ignore: longint;
				
			begin
				GetDialogItem(theDialog, DefaultItem, myType, myHand, myRect);
				HiliteControl(ControlHandle(myHand), 1);{make button appear to have been pressed}
				Delay(kVisualDelay, Ignore);
				HiliteControl(ControlHandle(myHand), 0);
				theItem := DefaultItem;
			end;
		{----------------}
	
	
	const 
		kTimeOut = 600;
		kReturn= char(13);
		kEnter=char(3);
	var 
		ch: char;
		
	BEGIN			
		timedDialog := false;
		case theEvent.what of
			keyDown,autoKey: 
				begin
				ch := char(BAnd(theEvent.message, charCodeMask));
				IF (ch = kReturn) OR (ch = kEnter) THEN
					begin
					ChooseDefault;	
					timedDialog := true;
					end;
				end;
			otherwise
				;
			end;{case} 
		if (theEvent.when) - timedDialogStartTime > kTimeOut then 
			begin	
			ChooseDefault;
			timedDialog := true;
			end;
END;
	
{ --------------------------------------------------------------------------}
	procedure InitTimedDialog;

	begin
		timedDialogUPP := NewRoutineDescriptor(@timedDialog,uppModalFilterProcInfo,GetCurrentISA);
		IF  timedDialogUPP = NIL THEN 
			begin
			Error('[InitTimedDialog] Cannot allocate timedDialogUPP',0,0,false,true);
			exitToShell;{should have happened in Errors&Beeps already}
			end;	
	end;
 

{----------------------------------------------}

procedure ReportMem; { Used for debugging}

var
	total:			LongInt;				{total free memory if heap purged}
	contig:			LongInt;				{largest contiguous block if heap purged}
	
BEGIN
	PurgeSpace(total, contig);
	warning(stringOf('MEM: ',total,' / ',contig),0,false);
END;
{----------------------------------------------}

FUNCTION MemAvail (memRequest: LongInt): Boolean;

CONST
	kMemCushion =				60 * 1024;							{size of memory cushion}
VAR
	total:			LongInt;				{total free memory if heap purged}
	contig:			LongInt;				{largest contiguous block if heap purged}
	
BEGIN
	PurgeSpace(total, contig);
	if alreadyHadMemError then {try to use the memory cushion}
		MemAvail := ((memRequest) < contig)
	else
		MemAvail := ((memRequest + kMemCushion) < contig);
END;
	
{----------------------------------------------}
	procedure Play (WhichSound: integer);

		var
			SoundHandle: SndListHandle;
			SoundChannel: SndChannelPtr;
			SoundErr: OSErr;
	begin
	
		SoundChannel := nil; {let SndPlay allocate Channel}
		SoundHandle := SndListHandle(GetResource('snd ', WhichSound));
		if SoundHandle <> nil then
			begin
			SoundErr := SndPlay(SoundChannel, SoundHandle, true);
			If SoundErr <> NoErr then sysBeep(0);
			end;
	end;

{----------------------------------------------}
	procedure FatOkBox (Dialog: DialogPtr);
		const
			DefaultButton = 1;
		var
			ItemType: Integer;
			item: Handle;
			itembox: rect;
			DefaultPort: GrafPtr;
	begin
		GetPort(DefaultPort);
		SetPort(Dialog);
		GetDialogITem(Dialog, DefaultButton, itemType, item, itembox);
		insetRect(itembox, -4, -4);
		PenSize(3, 3);
		FrameRoundRect(itembox, 16, 16);
		PenSize(1, 1);
		SetPort(DefaultPort);
	end;

{----------------------------------------------}
	procedure Warning (Message: str255; LineNr: longint; sayWarning:boolean);
	
	begin
		if not InfoOnly and not aborted then
			begin
			if SetUp^^.VerboseLogging then
				begin
				if LineNr <> 0 then
					message := concat(message, stringof(' [',stringList(DXFLineNrStr),LineNr,']'));
				if sayWarning then message := concat(stringlist(WarningNr), Message);
				writeLog(Message);
				end;
			end;
	end;


{----------------------------------------------}
	procedure InitError;
			
	begin
		GetPort(oldPort);
		ErrorWindow := GetNewDialog(ErrorId, nil, Pointer(-1));
		SetPort(ErrorWindow);
		HideWindow(ErrorWindow);
		SetPort(oldPort);
		errorstring := stringlist(errstrNr);
		MemoryErrorstring := stringlist(OutOfMemNr);
		alreadyHadMemError := false;
	end; 
	
{----------------------------------------------}
	procedure Error (varstring: str255; str1Nr, LineNr: longint; logIt, MemError: boolean);
		var
			TheItem: Integer;
			str1, str2: string;
	begin
		if MemError then {memory error, try to get the message across without 
											using too much memory, then quit 'gracefully'}
			begin
			if alreadyHadMemError then {hopeless, just go}
				exitToShell;
			varstring := concat(varstring, '. ', MemoryErrorstring);
			Paramtext(errorstring, varstring, '', '');
			SetCursor(QD.Arrow);
			showWindow(errorWindow);
			SelectWindow(errorWindow);
			SetPort(errorWindow);
			alreadyHadMemError := true;
			ModalDialog(nil, TheItem);
			if DrwWinInited then disposeDialog(DrawWindow);
			disposeWindow(errorWindow);
			writelog(errorstring);
			writelog(concat(' ', varstring));
			if logWinOpen then
				if closelog then; {try saving the log if necessary, will fail in very tight situations}
			exitToShell;
			end
		else {"normal" errors, use more flashy message}
			begin
			if not aborted then {don't mention errors if already aborted}
				begin
				if DrwWinInited and not doBackground then copyToGWorld(drawWindow);
				GetPort(oldPort);
				play(Dong);
				if str1Nr <> 0 then
					str1 := stringlist(str1Nr)
				else
					str1 := '';
				if LineNr <> 0 then
					str2 := stringof('[',stringList(DXFLineNrStr),LineNr,']')
				else
					str2 := '';
				varstring := concat(varstring, ' ', str1, ' ', str2);
				Paramtext(errorstring, varstring, '', '');
				SetCursor(QD.Arrow);
				showWindow(errorWindow);
				SelectWindow(errorWindow);
				SetPort(errorWindow);
				FatOkBox(errorWindow);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				hideWindow(errorWindow);
				if LogIt then {log error message}
					begin
						writelog(errorstring);
						writelog(concat(' ', varstring));
					end;
				SetCursor(QD.Arrow);
				setPort(oldPort);
				if DrwWinInited  and not doBackground then copyFromGWorld(drawWindow);
				Paramtext('', '', '', '');
				end;
			end;
		
	end;

{----------------------------------------------}
	function GetARes (resType: OSType; resID: Integer): Handle;

		var
			theRes: Handle;
			resErr: integer;

	begin
		theRes := GetResource(resType, resID);
		resErr := ResError;
		if theRes = nil then
			error(stringOf(stringlist(ResCorruptNr), ' (ID=', resID : 1, '; Error=', resErr : 1, ').'), 0, 0, false,false);
		GetARes := theRes;
	end;


{----------------------------------------------}
end. {of unit ErrorsAndBeeps}