unit IO;


{ ############  DXF TO ILLUSTRATOR #############################
    1991-2002 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            
						
 ########################################################
 Version 2.2 -  programmed by B.J. Kbben	summer/fall 1996
			
Changed all calls to UIP calls (FS*** calls). Makes us 7.x dependent, but what the heck...
Introduced unit IO.p (and IO.rsrc) for opening and closing files.
########################################################}

interface

uses
{Mac Toolbox Units}
	Processes,GestaltEqu,Files,Finder,Script,types,memory,
	StandardFile,TextUtils,Resources,Dialogs,Errors,
	Types, Devices, Events, Windows,QuickDraw,OSUtils
	;
	
type
		IO_MessageKind = (CRASH, stop, note, caution);

Function IO_OpenReadFile(var IO_FileRefNum:integer; var IO_Reply:StandardFileReply;
										 Filter:OSType; Permission: integer; droppedFileSpecs: FSSpecPtr):boolean;
Function IO_OpenWriteFile(var IO_FileRefNum:integer; var IO_Reply:StandardFileReply;
										FileCreator, FileType:OSType; prompt,defaultName: str255;Permission:integer;
										droppedFileSpecs: FSSpecPtr):boolean;
Procedure IO_CloseFile (IO_FileRefNum:integer; IO_Specs:FSSpec);

implementation

	const
		UsrCanceledErr = -1;
		FatalError=1;
		IOError = 2;
		ResError =3;
		OSOldErr = 4;
		Yes=987;
	
	var
		myFileRefNum,IO_IsInited:integer;
		
		
{----------------------------------------------}
	procedure FatOkBox (Dialog: DialogPtr);
		const
			DefaultButton = 1;
		var
			ItemType: Integer;
			item: Handle;
			itembox: rect;
			DefaultPort: GrafPtr;
	begin
		GetPort(DefaultPort);
		SetPort(Dialog);
		GetDialogItem(Dialog, DefaultButton, itemType, item, itembox);
		insetRect(itembox, -4, -4);
		PenSize(3, 3);
		FrameRoundRect(itembox, 16, 16);
		SetPort(DefaultPort);
	end;
	
{----------------------------------------------------------------------------}
	function messageStr (nr,myErr: integer): str255;
	
	const
		stringListlength = 4;
		stringListID = 3000;
		nrResultCodes = 31;
		unknownCode = 32;
		ResultCodeID = 3001;
		
	var 
		message,resultCode,tempCode:str255; i:integer; gotHim:boolean;
		resultNr:longint;

	begin
		if (nr > 0) and (nr <= stringListLength) then 
			begin
			GetIndString(message,StringListID, nr);
			if myErr<>0 then
				begin
				gotHim := false;
				for i := 1 to nrResultCodes do 
					begin
					GetIndString(tempCode,ResultCodeID,i);
					stringToNum(Copy(tempCode,1,Pos(':',tempCode)-1),resultNr);
					if resultNr =myErr then
						begin
						GotHim := true;
						resultCode :=Copy(tempCode,Pos(':',tempCode)+1,Length(tempCode)-Pos(':',tempCode));
						end;
					end; {for ...}
				if not GotHim then
					GetIndString(resultCode,ResultCodeID,unknownCode);
				message := stringOf(message,chr(13),'[',myErr,'] ',resultCode)
				end;
			end
		else
			begin
				sysBeep(0);
				message := stringOf('IO message STR# ', nr : 1, ' not found');
			end;
		messageStr := message;
	end;
	
{----------------------------------------------------------------------------}
	procedure IO_GiveAlert (what: IO_MessageKind; message: str255);

		const
			AlertID = 9999; {  with an OK-button and a Static text: ^0 }

		var
			Alert: integer;

	begin
		if what = CRASH then
			message := concat(messageStr(FatalError,0), message);
		ParamText(message, '', '', '');
		case what of
			stop: 
				Alert := StopAlert(AlertID, nil);
			note: 
				Alert := NoteAlert(AlertID, nil);
			caution: 
				Alert := CautionAlert(AlertID, nil);
			CRASH: 
				begin
					Alert := StopAlert(AlertID, nil);
					exitToShell;
				end;
		end;
	end;

	{------------------------------------------------------------}
		FUNCTION FSSpecRoutinesAvail: Boolean;
			VAR
				myErr:					OSErr;				{Gestalt result code}
				myFeature:			LongInt;			{Gestalt response}
				
			BEGIN
				FSSpecRoutinesAvail := FALSE;
				myErr := Gestalt(gestaltFSAttr, myFeature);
					IF myErr = noErr THEN
						IF BTst(myFeature, gestaltHasFSSpecCalls) THEN
							FSSpecRoutinesAvail := TRUE;
			END;
			
	{------------------------------------------------------------}
	procedure IO_init;
	
	begin
		if not FSSpecRoutinesAvail then
				IO_Givealert(CRASH,messageStr(OSOldErr,0));
		IO_IsInited := yes;
	end;

{----------------------------------------------------------------------------}
FUNCTION DoOpenFile (var FileRefNum: Integer; mySpec: FSSpec; Permission: integer): OSErr;
			
	BEGIN
		DoOpenFile := FSpOpenDF(mySpec, Permission,FileRefNum);
	END;

{----------------------------------------------------------------------------}
FUNCTION DoOpenWriteFile (var FileRefNum: Integer; mySpec: FSSpec; FCreator,FType:OSType; 
													Permission: integer;ReplaceOld:boolean): OSErr;
			
	var myErr: OSerr;
	
	BEGIN
		myErr := noErr;
		IF NOT ReplaceOld THEN
			myErr := FSpCreate(mySpec, FCreator,FType, smSystemScript)
		else
			begin
			myErr := FSpDelete(mySpec);
			if myErr = noErr then
				myErr := FSpCreate(mySpec, FCreator,FType, smSystemScript);
			end;
		if myErr = noErr then
			myErr := FSpOpenDF(mySpec, Permission,FileRefNum);
		DoOpenWriteFile := myErr;
	END;
	
{----------------------------------------------------------------------------}
Procedure IO_CloseFile (IO_FileRefNum:integer; IO_Specs:FSSpec);

var myErr:OSErr;
			
	BEGIN
		If IO_IsInited <> yes then IO_Init;
		myErr := FSClose(IO_FileRefNum);
		if myErr = noErr then
			myErr := FlushVol(nil,IO_Specs.vrefNum);
		if myErr <> noErr then
			IO_Givealert(stop,concat('[IO_CloseFile] ',messagestr(IOError,myErr)));
	END;
{----------------------------------------------------------------------------}
Function IO_OpenWriteFile(var IO_FileRefNum:integer; var IO_Reply:StandardFileReply;
										FileCreator, FileType:OSType; prompt,defaultName: str255;Permission:integer;
										droppedFileSpecs: FSSpecPtr):boolean;
	
	VAR					
		myErr:			OSErr;
		myReply:		StandardFileReply;
		FileOpen: 	boolean;
		
	BEGIN
		If IO_IsInited <> yes then IO_Init;
		myFileRefNum := 0; {none determined yet}
		
		if droppedFileSpecs = nil then {opened from menu}
			begin
			StandardPutFile(prompt,defaultName,myReply);
			IF myReply.sfGood THEN
				begin
					myErr := DoOpenWriteFile(myFileRefNum, myReply.sfFile,FileCreator, FileType, Permission,myReply.sfReplacing);
				end
			ELSE
				myErr := UsrCanceledErr;
			if myErr = noErr then
			 	FileOpen := true
		 	else
			 	begin
			 	FileOpen := false;
			 	if myErr <> UsrCanceledErr then
					IO_Givealert(caution,concat('[IO_OpenWriteFile:1] ',messagestr(IOError,myErr)));
			 	end;
			end {menu-opened}
		else {someone dropped a file on me}
			begin
			myErr := DoOpenWriteFile(myFileRefNum, droppedFileSpecs^,FileCreator, FileType, Permission,false);
			if myerr = dupFNErr then {already exists}
				myErr := DoOpenWriteFile(myFileRefNum, droppedFileSpecs^,FileCreator, FileType, Permission,true); {overwrite old}
			if myErr = noErr then
			 	FileOpen := true
			 else
			 	begin
			 	FileOpen := false;
				IO_Givealert(caution,concat('[IO_OpenWriteFile:2] ',messagestr(IOError,myErr)));
			 	end;
			end; {file-dropped}
		
	 	IO_Reply := myReply;
	 	IO_FileRefNum:= myFileRefNum;			
		IO_OpenWriteFile:=FileOpen;
	END;
	
{----------------------------------------------------------------------------}
Function IO_OpenReadFile(var IO_FileRefNum:integer; var IO_Reply:StandardFileReply;
										 Filter:OSType; Permission: integer;droppedFileSpecs: FSSpecPtr):boolean;
	
		{Permission values: fsRdPerm, fsRdWrPerm, fsRdRwShPerm }
		
	VAR
		myTypes:		ConstSFTypeListPtr;							
		myErr:			OSErr;
		myReply:		StandardFileReply;
		FileOpen: 	boolean;
		nrTypes:		integer;
		
	BEGIN
		If IO_IsInited <> yes then IO_Init;
		myFileRefNum := 0; {none determinded yet}
		
		if droppedFileSpecs = nil then {opened from menu}
			begin
			MyTypes := ConstSFTypeListPtr(newPtr(SizeOf(MyTypes)));
			myTypes :=nil;
			if Filter <> '_ALL' then
				begin
				nrTypes := 1;
				myTypes := @Filter;
				end
			else
				begin
				nrTypes := 0;
				myTypes := nil;	
				end;					
			StandardGetFile(NIL,nrTypes, myTypes, myReply);
			IF myReply.sfGood THEN
				myErr := DoOpenFile(myFileRefNum, myReply.sfFile, Permission)
			ELSE
				myErr := UsrCanceledErr;
			if myErr = noErr then
			 	FileOpen := true
		 	else
			 	begin
			 	FileOpen := false;
			 	if myErr <> UsrCanceledErr then
					IO_Givealert(caution,concat('[IO_OpenReadFile 1 ]',messagestr(IOError,myErr)));
			 	end;
			DisposePtr(Ptr(MyTypes));
			end {menu-opened}
		else {someone dropped a file on me}
			begin
			myErr := DoOpenFile(myFileRefNum, droppedFileSpecs^, Permission);
			if myErr = noErr then 
				FileOpen := true
			else
				begin
				IO_Givealert(caution,concat('[IO_OpenReadFile 2] ',messagestr(IOError,myErr)));
				FileOpen := false;
				end;
			end; {file-dropped}
		
	 	IO_Reply := myReply;
		IO_FileRefNum:= myFileRefNum;
		IO_OpenReadFile:=FileOpen;
	END;
	
{------------------------------------------------------------}



end. {of unit FileIO}


