unit MyPrint;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-2002 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{							- new unit, not in previous versions													}
{    Version 2.0    - Programmed by B.J. Kbben:                          
		Version 2.2OS - code and app made OpenSource July 2002 BJK     				              	}
{ ########################################################}



interface
	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,processes,
	Dialogs,Types,TextEdit,TextUtils,toolutils,OSutils,Printing,QDOffscreen,
		{MyUnits}
		globals, ErrorsAndBeeps, log, Scale,  myFiles;

	procedure PaginaInstelling;
	procedure Print;

implementation

	var
		PrinterPort: TPPrPort; {printing vars}
		statusRec: TPrStatus;

{----------------------------------------------------------------------------}
	procedure PaginaInstelling;

	begin
		setCursor(QD.arrow);
		prOpen;
		PrintDefault(prRecHdl);
		if prStlDialog(prRecHdl) then
			if prError <> NoErr then
				begin
					Error(stringlist(NoPrinterNr), 0, 0, false,false);
				end;
		prClose;
	end;

{----------------------------------------------------------------------------}
	procedure Print;

		var
			CurrentLine, i, LineHoogte: integer;
			PrintDialog: DialogPtr;
			printPage: rect;
			LinesPerPage, x, y: integer;

	begin
		setCursor(QD.arrow);
		GetPort(oldPort);
		prOpen;
		PrintDefault(prRecHdl);
		if prJobDialog(prRecHdl) then
			begin
				PrinterPort := PrOpenDoc(prRecHdl, nil, nil);
				if PrError = NoErr then
					begin
						ParamText(stringlist(logStrNr), '', '', '');
						PrintDialog := GetNewDialog(PrintDlogID, nil, pointer(-1));
						DrawDialog(PrintDialog);

						printPage := PrRecHdl^^.prInfo.rPage;
						lineHoogte := LogTextLineHeight; {declared in log.p}
						
						LinesPerPage := roundtol((printPage.bottom - printPage.top) / lineHoogte - 1);

						ClipRect(printPage); {set the ClipRgn to the page}
						TextFont(CurrentFont);
						TextSize(CurrentSize);
						i := 0;
						CurrentLine := 0;
						x := 0;
						y := 0;

						while CurrentLine < LogLine do
							begin
								PrOpenPage(PrinterPort, nil);
								while i < LinesPerPage do
									begin
										i := i + 1;
										y := y + LineHoogte;
										moveto(x, y);
										CurrentLine := CurrentLine + 1;
										DrawString(LogText^^[CurrentLine]);
									end;
								i := 0;
								y := 0;
								PrClosePage(PrinterPort);
							end;

						DisposeDialog(PrintDialog);
					end;
				PrCloseDoc(PrinterPort);
				if (prRecHdl^^.prJob.bJDocLoop = bSpoolLoop) and (PrError = NoErr) then
					begin
						PrPicFile(prRecHdl, nil, nil, nil, statusRec);
					end;
				case PrError of
					noErr: 
						begin  {everything OK}
						end;
					iPrAbort: 
						begin
						{printing aborted}
						end;
					otherwise
						begin
							Error(stringlist(NoPrinterNr), 0, 0, false,false);
						end;
				end; {case}
			end;
		PrClose;
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
end. {of unit MyPrint}