
{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991      						}
{ 	Version 2.0     -  Changes programmed by B.J. Kbben, november/december 1992      }
{ 	 							- Scaling: IllMaxX and Y are now functions instead of constants      }
{ 	 								These are set in this new unit Scale, and configured in setUp    
		Version 2.2OS - code and app made OpenSource July 2002 BJK  }
{ ########################################################}

unit Scale;


interface
	uses
		{UIP}
			QuickDraw,memory,types,windows,fp,TextEdit,QuickDrawText,fonts,events,
		{myUnits}
			Printing, globals, ErrorsAndBeeps;

	const
		mm = 1; 							{=1}
		inch = 0.03937007874; 	{=1/25,4 mm}
		points = 2.8346456693; 	{= 1/(25,4 / 72 )}

	var
		eenheidStr: str32;
		eenheid: extended;
		Scaling: byte;
		CustomX: extended; {opgeslagen in stup in mm's}
		illscale, XMargin, YMargin: extended;
		CusXRsc, marginsRsc: Handle;
		CusXStr: str255;

	type
		XorY = (x, y);


	function IllMaxX: extended;
	function IllMaxY: extended;

{---------------------------------------------------}
implementation

	const
		A4tallX = 595;    {values in points (values in version 1.2.0: 520x760)}
		A4tallY = 842;
		A4wideX = 842;
		A4wideY = 595;
		A3tallX = 842;
		A3tallY = 1191;
		A3wideX = 1191;
		A3wideY = 842;
	var
		tempMax: extended;

{---------------------------------------------------}
	procedure GetMargins;
		var
			dump: boolean;
			Paper, Page: rect;
	begin
		PrOpen;
		if PrError = NoErr then
			begin
				dump := PrValidate(prRecHdl);
				if PrError = NoErr then
					begin
						Paper := PrRecHdl^^.rPaper;
						Page := PrRecHdl^^.prInfo.rPage;
						XMargin := abs(Page.right - (Paper.right - paper.left)) + 3;  {extra 3 for safety, screws scale up a bit, but}
						YMargin := abs(Page.bottom - (Paper.bottom - paper.top)) + 3; {in this case fitting on page is more important}
						prClose;
					end;
			end
		else
			begin
				if (not DonePrinterError) and (not infoOnly) then
					begin
					Error(stringlist(NoPrinterNr), 0, 0, true,false);
					DonePrinterError := true;
					end;
				XMargin := 0;
				YMargin := 0;
			end;
	end;

{---------------------------------------------------}
	function IllMaxX: extended;
	begin
		case SetUp^^.Scaling of
			ToA4Tall: 
				tempMax := A4tallX;
			ToA4wide: 
				tempMax := A4wideX;
			ToA3Tall: 
				tempMax := A3tallX;
			ToA3wide: 
				tempMax := A3wideX;
			ToCustom: 
				begin
					CustomX := SetUp^^.CustomScale;
					tempMax := (CustomX * points);
					SetUp^^.useMargins := false; {never useMargins if customXY}
				end;
			otherwise
				Error(stringlist(ScaleErrorNr), 0, 0, false,false);
		end; {of case}
		if SetUp^^.useMargins then
			begin
				GetMargins;
				IllMaxX := tempMax - XMargin;
			end
		else
			IllMaxX := tempMax;
	end;

{---------------------------------------------------}
	function IllMaxY: extended;
	begin
		case SetUp^^.Scaling of
			ToA4Tall: 
				tempMax := A4tallY;
			ToA4wide: 
				tempMax := A4wideY;
			ToA3Tall: 
				tempMax := A3tallY;
			ToA3wide: 
				tempMax := A3wideY;
			ToCustom: 
				;{only occurs in IllMaxX}
			otherwise
				Error(stringlist(ScaleErrorNr), 0, 0, false,false);
		end; {of case}
		if SetUp^^.useMargins then
			begin
				GetMargins;
				IllMaxY := tempMax - YMargin;
			end
		else
			illMaxY := tempMax;
	end;

{---------------------------------------------------}
end. {unit Scale}