unit illfile;


{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{  Version 2.1 - programmed by B.J. Kbben																	}
{					- Include fonts if Fontsubstitution on - 93													}
{					- preset to black if Colorsubstitution off - 8/94										}
{					- preset to 0.1 point if LWsubstitution off - 8/94										}
{		OutString(concat('%%TileBox:', tempstring)); added this in 2.2 to make them fit on page
		Version 2.2OS - code and app made OpenSource July 2002 BJK}
{ ########################################################}


interface
uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,processes,
	Dialogs,Types,TextEdit,TextUtils,toolutils,
		{MyUnits}
			globals, scale, myFiles, tables, setup, Ctm, layers;

	function sendpsheader (minx, miny, maxx, maxy: real): boolean;
	function sendPsTrailer (minx, miny, maxx, maxy: real): boolean;

implementation

	var
		headersent: boolean;

{------------------------------------------------------------}
	procedure outstring (data: string);
	begin
		if not WritelnString(IllFileNo, data) then
			headersent := False;
	end;



{------------------------------------------------------------}
	function sendpsheader (minx, miny, maxx, maxy: real): boolean;
		var
			i, j: byte;
			tempstring, t: str255;
			gotIt: boolean;
			
			
						
			
	begin
		transform(IllCtm, minx, miny);
		transform(IllCtm, maxx, maxy);
		headersent := True;
		OutString('%!PS-Adobe-2.0 EPSF-1.2');
		OutString(concat('%%Creator: DXF to Illustrator ', version));
		OutString(concat('%%For: ', SetUp^^.LicenseName));
		OutString('%%Title:');
		OutString(concat('%%CreationDate: ', dateTimeStr(1)));
		OutString('%%DocumentProcSets:Adobe_Illustrator_1.1 0 0');
		OutString('%%DocumentSuppliedProcSets:Adobe_Illustrator_1.1 0 0');
		OutString('%%DocumentFonts:Courier');
		if SetUp^^.Fontsubstitution then
			for i := 1 to maxnumFonts do
				begin
					if length(Setup^^.FontTable[i]) > 1 then {not only '\'}
						begin
							tempstring := copy(Setup^^.FontTable[i], pos('\', Setup^^.FontTable[i]) + 1, length(Setup^^.FontTable[i]));
							gotIt := false;
							for j := 1 to (i - 1) do
								begin
									t := copy(Setup^^.FontTable[j], pos('\', Setup^^.FontTable[j]) + 1, length(Setup^^.FontTable[j]));
									if (tempstring = t) then
										GotIt := true;
								end;
							if (tempstring <> 'Courier') and not GotIt then {its a new font}
								OutString(stringOf('%%+', tempstring));
						end;
				end;
		TempString := stringof(roundtol(minx) : 1, ' ', roundtol(miny) : 1, ' ', roundtol(maxx) : 1, ' ', roundtol(maxy) : 1);
		OutString(concat('%%BoundingBox:', tempstring));
		OutString(concat('%%TileBox:', tempstring)); { added this in 2.2 to make them fit on page}
		OutString('%%EndComments');
		OutString('%%BeginProcSet:Adobe_Illustrator_1.1 0 0');
		OutString('% Copyright (C) 1987 Adobe Systems Incorporated.');
		OutString('% All Rights Reserved.');
		OutString('% Adobe Illustrator is a trademark of Adobe Systems Incorporated.');
		OutString('/Adobe_Illustrator_1.1 dup 100 dict def load begin');
		OutString('/Version 0 def');
		OutString('/Revision 0 def');
		OutString('% definition operators');
		OutString('/bdef {bind def} bind def');
		OutString('/ldef {load def} bdef');
		OutString('/xdef {exch def} bdef');
		OutString('% graphic state operators');
		OutString('/_K {3 index add neg dup 0 lt {pop 0} if 3 1 roll} bdef');
		OutString('/_k /setcmybcolor where ');
		OutString('{/setcmybcolor get} {{1 sub 4 1 roll _K _K _K setrgbcolor pop} bind} ifelse def');
		OutString('/g {/_b xdef /p {_b setgray} def} bdef');
		OutString('/G {/_B xdef /P {_B setgray} def} bdef');
		OutString('/k {/_b xdef /_y xdef /_m xdef /_c xdef /p {_c _m _y _b _k} def} bdef');
		OutString('/K {/_B xdef /_Y xdef /_M xdef /_C xdef /P {_C _M _Y _B _k} def} bdef');
		OutString('/d /setdash ldef');
		OutString('/_i currentflat def');
		OutString('/i {dup 0 eq {pop _i} if setflat} bdef');
		OutString('/j /setlinejoin ldef');
		OutString('/J /setlinecap ldef');
		OutString('/M /setmiterlimit ldef');
		OutString('/w /setlinewidth ldef');
		OutString('% path construction operators');
		OutString('/_R {.25 sub roundtol .25 add} bdef');
		OutString('/_r {transform _R exch _R exch itransform} bdef');
		OutString('/c {_r curveto} bdef');
		OutString('/C /c ldef');
		OutString('/v {currentpoint 6 2 roll _r curveto} bdef');
		OutString('/V /v ldef');
		OutString('/y {_r 2 copy curveto} bdef');
		OutString('/Y /y ldef');
		OutString('/l {_r lineto} bdef');
		OutString('/L /l ldef');
		OutString('/m {_r moveto} bdef');
		OutString('% error operators');
		OutString('/_e [] def');
		OutString('/_E {_e length 0 ne {gsave 0 g 0 G 0 i 0 J 0 j 1 w 10 M [] 0 d');
		OutString('/Courier 20 0 0 1 z [0.966 0.259 -0.259 0.966');
		OutString('_e 0 get _e 2 get add 2 div _e 1 get _e 3 get add 2 div] e _f t T grestore} if} bdef');
		OutString('/_fill {{fill} stopped');
		OutString(concat('{/_e [pathbbox] def /_f (ERROR: can', char(39), 't fill, increase flatness) def n _E} if} bdef'));
		OutString('/_stroke {{stroke} stopped');
		OutString(concat('{/_e [pathbbox] def /_f (ERROR: can', char(39), 't stroke, increase flatness) def n _E} if} bdef'));
		OutString('% path painting operators');
		OutString('/n /newpath ldef');
		OutString('/N /n ldef');
		OutString('/F {p _fill} bdef');
		OutString('/f {closepath F} bdef');
		OutString('/S {P _stroke} bdef');
		OutString('/s {closepath S} bdef');
		OutString('/B {gsave F grestore S} bdef');
		OutString('/b {closepath B} bdef');
		OutString('% text block construction and painting operators');
		OutString('/_s /ashow ldef');
		OutString('/_S {(?) exch {2 copy 0 exch put pop dup false charpath currentpoint _g setmatrix');
		OutString('_stroke _G setmatrix moveto 3 copy pop rmoveto} forall pop pop pop n} bdef');
		OutString('/_A {_a moveto _t exch 0 exch} bdef');
		OutString('/_L {0 _l neg translate _G currentmatrix pop} bdef');
		OutString('/_w {dup stringwidth exch 3 -1 roll length 1 sub _t mul add exch} bdef');
		OutString('/_z [{0 0} bind {dup _w exch neg 2 div exch neg 2 div} bind {dup _w exch neg exch neg} bind] def');
		OutString('/z {_z exch get /_a xdef /_t xdef /_l xdef exch findfont exch scalefont setfont} bdef');
		OutString('/_g matrix def');
		OutString('/_G matrix def');
		OutString('/_D {_g currentmatrix pop gsave concat _G currentmatrix pop} bdef');
		OutString('/e {_D p /t {_A _s _L} def} bdef');
		OutString('/r {_D P /t {_A _S _L} def} bdef');
		OutString('/a {_D /t {dup p _A _s P _A _S _L} def} bdef');
		OutString('/o {_D /t {pop _L} def} bdef');
		OutString('/T {grestore} bdef');
		OutString('% group construction operators');
		OutString('/u {} bdef');
		OutString('/U {} bdef');
		OutString('% font construction operators');
		OutString('/Z {findfont begin currentdict dup length dict begin');
		OutString('{1 index /FID ne {def} {pop pop} ifelse} forall /FontName exch def dup length 0 ne');
		OutString('{/Encoding Encoding 256 array copy def 0 exch {dup type /nametype eq');
		OutString('{Encoding 2 index 2 index put pop 1 add} {exch pop} ifelse} forall} if pop');
		OutString('currentdict dup end end /FontName get exch definefont pop} bdef');
		OutString('end');
		OutString('%%EndProcSet');
		OutString('%%EndProlog');
		OutString('%%BeginSetup');
		OutString('Adobe_Illustrator_1.1 begin');
		OutString('n');
		OutString('%%EndSetup');
		OutString('0 g');
		OutString('0 G');
		OutString('0 i');
		Outstring('2 J');{projecting square linecaps}
		OutString('0 j');
		Outstring(concat(DefaultLW, ' w'));
		OutString('0 0 0 1 k  %default fill color = black');
		OutString('0 0 0 1 K  %default stroke color= black');
		Outstring('10 M');
		Outstring('[] 0 d');
		SendPsHeader := headersent;
	end;


{------------------------------------------------------------}
	function sendPsTrailer (minx, miny, maxx, maxy: real): boolean;
		var
			customX: extended;
			message: str255;

			{-----------------------------}
			procedure WriteConvertorStamp;
			
			var Ypos,Xpos :integer;
				
				{-----------------}
				procedure nextLine;
					begin
					OutString('T');
					Ypos := Ypos - 6;
					OutString(StringOf('[1 0 0 1 ', Xpos : 1, ' ', Ypos : 1, '] e'));
					end;
				{-----------------}
					
				begin
					Ypos := roundtol(maxy);
					Xpos := roundtol(minx);
					if (SetUp^^.TargetAppl = Ill50) then {Illlustrator 5.0 layers}
						begin
							outstring('%A15_BeginLayer');
							outstring('1 1 1 1 0 0 8 0 0 0 Lb');
							outstring('(ConversionStamp) Ln');
						end;
					Outstring('u');
					OutString(StringOf('/_Courier 6 6 0 0 z '));
					
					OutString(StringOf('[1 0 0 1 ', Xpos : 1, ' ', Ypos : 1, '] e'));
					OutString(concat('(DXF to Illustrator ', version,' [',stringList(LicensedToNr), SetUp^^.LicenseName,']',') t'));
					nextLine; 
					OutString(concat('(', GetFname(DxfFileNo), ' -> ', GetFname(IllFileNo), ') t'));
					nextLine; 
					if SetUp^^.scaling = ToCustom then {custom scaling}
						begin
							CustomX := SetUp^^.customScale;
							Message := concat(stringlist(ScaleToNr + byte(SetUp^^.scaling)), StringOf((CustomX * eenheid) : 1 : 7, ' ', EenheidStr));
							Outstring(concat('(', message, ') t'));
							nextLine; 
						end
					else
						begin
							Message := concat(stringlist(ScaleToNr + byte(SetUp^^.scaling)), StringOf((illscale / points) : 1 : 7, ' mm.'));
							Outstring(concat('(', message, ') t'));
							nextLine; 
						end;
					case SetUp^^.TargetAppl of
						Ill11: 
							Outstring(concat('(', stringList(TargetApplNr), stringList(OtherApplNr), ') t'));
						Freehand: 
							Outstring(concat('(', stringList(TargetApplNr), stringList(FreehandFormatNr), ') t'));
						Ill50: 
							Outstring(concat('(', stringList(TargetApplNr), stringList(layerFormatNr), ') t'));
					end;{case}
					nextline;
					case SetUp^^.Grouping of
						full: 
							Outstring(concat('(', stringList(FullGroupNr), ') t'));
						byLayer: 
							Outstring(concat('(', stringList(LayerGroupNr), ') t'));
						none: 
							Outstring(concat('(', stringList(NoGroupNr), ') t'));
					end;{case}
					nextline;
					if SetUp^^.Tielines then
						BEGIN
						Outstring(concat('(', stringList(TieLinesYesNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.LineweightSubstitution then
						begin
						Outstring(concat('(', stringList(LSonNr), ') t'));
						nextLine; 
						end
					else
						begin
						Outstring(concat('(', stringList(LSoffNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.FontSubstitution then
						begin
						Outstring(concat('(', stringList(FSonNr), ') t'));
						nextLine; 
						end
					else
						begin
						Outstring(concat('(', stringList(FSoffNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.ColorSubstitution then
						begin
						Outstring(concat('(', stringList(CSonNr), ') t'));
						nextLine; 
						end
					else
						begin
						Outstring(concat('(', stringList(CSoffNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.FillSolid then
						begin
						Outstring(concat('(', stringList(FillSolidNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.FillCircle then
						begin
						Outstring(concat('(', stringList(FillCircleNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.FillPoly then
						begin
						Outstring(concat('(', stringList(FillPolyNr), ') t'));
						nextLine; 
						end;
					if SetUp^^.groupBlocks then
						begin
						Outstring(concat('(', stringList(groupBlocksNr), ') t'));
						nextLine; 
						end
					else
						begin
						Outstring(concat('(', stringList(notNr),stringList(groupBlocksNr), ') t'));
						nextLine; 
						end;
					OutString(concat('(', stringlist(CnvReadyNr),' [',dateTimeStr(0),']', ') t'));
					OutString('T');
					
					Outstring('U');
					if (SetUp^^.TargetAppl = Ill50) then {Illlustrator 5.0 layers}
						begin
							outstring('LB');
							outstring('%A15_EndLayer--');
						end;
					end;
			
			{-----------------------------}

	begin
		transform(IllCtm, minx, miny);
		transform(IllCtm, maxx, maxy);
		SendPsTrailer := False;
	  if Setup^^.Converterstamp then
			WriteConvertorStamp;
		if not WritelnString(IllFileNo, '%%Trailer') then
			exit(SendPsTrailer);
		if not WritelnString(IllFileNo, '_E end') then
			exit(SendPsTrailer);
		SendPsTrailer := True;
	end;

{------------------------------------------------------------}
end.