unit info;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-2002 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{ 	Version 2.0     -  Changes programmed by B.J. Kbben, november/december 1992      }
{ 	 							- Scaling: IllMaxX and Y are now reals instead of constants            }
{ 	 											These are set in the new unit Scale					            }
{ 	 							- Collecting Info changed  to find DXF fonts & Colors; jan 1993
		Version 2.2OS - code and app made OpenSource July 2002 BJK}
{  																																	}
{ ########################################################}

interface
	uses
		{UIP}
		processes,fp,Memory,Types,
		{MyUnits}
		globals, ErrorsAndBeeps, Scale, myFiles,myWindows;


	procedure Collectinfo (why: reason); {reason is declared in globals unit}

implementation

	function readsection (why: reason) : boolean;
	external;
	procedure InitLayers;
	external;
	function LayerCount: integer;
	external;
	procedure DisPoseLayers;
	external;


	procedure Collectinfo (why: reason);
		var
			group: grouptype;
			Cancelled, IsDxfFile: boolean;
			DxfFileSize, IllFileSize: longint;
			Layers, Ltypes: integer;

	begin
		InfoOnly := true;
		Cancelled := False;
		IsDxfFile := False;
		bbox_set := false;	
		aborted := false;
		numElems := 0;
		
		DonePrinterError := false;
		
		if not MemAvail(sizeof(strtype)) then 
			Error('[CollectInfo] ', OutOfMemNr, 0, true,true);
		group.strdat := strptr(newPtr(sizeof(strtype)));
		
		repeat
			if open_interactive(DxfFileno, nil) then
				begin
					if not SetInput(DxfFileNo) then
						begin
							disposePtr(Ptr(Group.strdat));
							exit(CollectInfo);
						end;
					DXFLineNR := 0;
					if readgroup(group, normal) then
						begin
							if group.datatype = STRINGTP then
								if group.strdat^ = 'SECTION' then
									IsDxfFile := True;
						end;
					if not IsDxfFile then
						begin
							Error(stringOf('',GetFName(DxfFileNo),''), NoDxfNr, DXFLineNr, false,false);
							closeFile(DxfFileNo);
						end;
				end
			else
				Cancelled := True;
		until Cancelled or IsDxfFile;
		{RemoveMessageWindow}
		if IsDxfFile then
			begin
				numTableThings := 0;   {2.1 change}
				BlockHatch := True;
				HatchAsked := true;
				Reset(DxfFileNo);
				DXFlineNr := 0;
				{}InitLayers;
				
				if why = normal then 
					begin
					if not DrwWinInited then
						CreateDrawingWindow(concat(stringList(Infonr),'',GetFName(DXFFileno),''));
					InitBalk(0,FileSize(DxfFileNo));	
					end;
				
				
				ACADversion := stringlist(unknownNoHeaderNr); {in case there's no header}
				if setinput(DxfFileNo) then
					while readsection(why) do
						; {keep reading sections until EOF}
				if why = normal then
					begin
						DxfFileSize := FileSize(DxfFileNo);
						IllFileSize := 3624 + roundtol((DxfFileSize) / 2.5);
						DxfFileSize := roundtol(DxfFileSize / 1024);
						IllFileSize := roundtol(IllFileSize / 1024);
						layers := LayerCount;
						ltypes := 0;
						repeat
							ltypes := ltypes + 1;
						until (ltypes = maxltypes) or (ltypeDash[ltypes].ltypename = '');
						ltypes := ltypes - 1;
						ShowInfo(ACADversion,DxfFileSize, IllFileSize, layers, ltypes, blockcount);
					end;
				{}DisposeLayers;
			end;
		if Group.strdat <> nil then disposePtr(Ptr(Group.strdat));
		closeFile(dxfFileNo);
		
		if why=normal then
			DoBalk(BalkMax);
		{cleaning up}
		if DrwWinInited then RemoveDrawingWindow;
		closeAllFiles; 
		DXFLineNR := 0;
		numElems := 0;
		
	end;  { of procedure CollectInfo}

end. {of unit}