unit log;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{							- new unit, not in previous versions													}
{    Version 2.0    new unit, rogrammed by B.J. Kbben:   july-august 1993                   	}
{    Version 2.1    changed to 400 lines of str80 - sept 1994             	      			          	}
{							print functions moved to this unit - sept 1994     
		Version 2.2OS - code and app made OpenSource July 2002 BJK        	      			   	}
{ ########################################################}



interface

uses
	{UIP}
		Types, Controls,Devices,Events, Dialogs, Menus,Fonts,Windows,Memory,QDOffscreen,
		Quickdraw,QuickDrawText, Resources,TextUtils,Toolutils,fp,TextEdit,Processes,Files,
	{myUnits}
		globals, ErrorsAndBeeps;

	const
		pt8 = 1;  {items in size menu}
		pt9 = 2;
		pt10 = 3;
		pt12 = 4;
		maxLinesInLog = 800;{global 'cos myPrint needs it}
		
	type {global 'cos myPrint needs it}
		LogTextType = array[1..maxLinesInLog] of str80;
		LogTextPtr = ^LogTextType;
		LogTextH = ^LogTextPtr;
		
	var
		LogWindow: windowPtr; {global 'cos its used in myFiles}
		currentSize, CurrentFont, CourierItem, sizeMenuSelection, FontMenuSelection, LogLine: integer;
		LogWinVis: boolean;
		LogTextLineHeight : integer;{global 'cos myPrint needs it}
		LogText: logTextH;{global 'cos myPrint needs it}



	function askSaveLog: integer;
	procedure initLog;
	procedure openlogWin;
	procedure showHidelog;
	procedure DoScrolling (loc: point);
	function closeLog: boolean;
	procedure clearlog;
	procedure openlogFile;
	procedure savelog;
	procedure updateLogWindow;
	procedure writeLog (message: str80);
	procedure NewLogtext (currentFont, currentSize: integer);

implementation

{first some externals: Because we need them here, but THEY need to be logged!}
	function writeLOGF (fileno: integer; Str: str255): boolean;
	external;
	function open_interactive (var fileno: integer; droppedFileSpecs: FSSpecPtr): boolean;
	external;
	function create_interactive (var fileno: integer; prompt: string; suggno: integer; droppedFileSpecs: FSSpecPtr): boolean;
	external;
	procedure reset (fileno: integer);
	external;
	procedure rewrite (fileno: integer);
	external;
	function readline (fileno: integer; var nwstring: string): boolean;
	external;
	function getfname (fileno: integer): string;
	external;
	procedure CloseFile (fileno: integer);
	external;


	const
		scrollCtrlNo = 128;
		Save = 1; 
		Cancel = 2;
		dontSave = 3;
		ShowLogID = 110;
		HideLogID = 111;

	var
		MyTextH: TEHandle;
		LogSaved: boolean;
		ScrollCtrl: ControlHandle;
		ScrollRect: rect;
		logTxtPos, logTxtMin, LogTxtMax, LinesInWin: integer;
		dump: integer;
		FInfo: FontInfo;
		Disposed: boolean;
		textRect: rect;
		showLogStr, HideLogStr: str255;


{----------------------------------------------------------------------------}
	function askSaveLog: integer;
			
		var
			DlogPtr: DialogPtr;
			TheItem: integer;

	begin
		GetPort(oldPort);
		SetCursor(QD.arrow);
		DlogPtr := GetNewDialog(SaveLogDlogID, nil, Pointer(-1));
		FatOkBox(DlogPtr);
		play(Dong);
		ModalDialog(nil, TheItem);
		AskSaveLog := theItem;
		DisposeDialog(Dlogptr);
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure WriteToWindow (txt: str80);
		var
			strP: StringPtr;
			i: byte;
	begin
		if not MemAvail(sizeof(str255)) then 
			Error('[writeToWindow] ', OutOfMemNr, 0, true,true);
		strP := StringPtr(newPtr(sizeof(str255)));
		
		for i := 1 to length(txt) do
			strP^[i-1] := txt[i];
		TESetSelect(32767, 32767, MyTextH);
		TEInsert(Pointer(strP), length(txt), MyTextH);
		TESetSelect(32767, 32767, MyTextH);
		TEKey(chr(13), MyTextH);
		disposePtr(Ptr(strP));
	end;

{----------------------------------------------------------------------------}
	procedure drawLogThings;

	begin
		GetPort(oldPort);
		setcursor(getcursor(watchcursor)^^);
		SetPort(LogWindow);
		GetFontInfo(FInfo);
		with FInfo do
			begin
				MyTextH^^.lineheight := ascent + descent + leading;
				LogTextLineHeight := MyTextH^^.lineheight;
				MyTextH^^.fontascent := ascent;
			end;
		LinesInWin := roundtol((textRect.bottom - textRect.top) / MyTextH^^.lineheight) - 1; {fits on page,1 overlap }
		logTxtMax := MyTextH^^.nLines - linesInWin + 1;
		if linesinWin > MyTextH^^.nLines then
			HiliteControl(ScrollCtrl, 255)  {dim scrollbar}
		else
			HiliteControl(ScrollCtrl, 0);	{make scrollbar useable}
		EraseRect(textRect);
		TEUpdate(textRect, MyTextH);
		SetControlMaximum(ScrollCtrl, logTxtMax);
		DrawControls(Logwindow);
		setCursor(QD.arrow);
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure NewLogtext (currentFont, currentSize: integer);
		var i:integer;
	
	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		setcursor(getcursor(watchcursor)^^);
		if not Disposed then
			begin
				TEDispose(MyTextH);
				disposeControl(ScrollCtrl);
				Disposed := true;
			end;
		MyTextH := TENew(textRect, textRect);
		MyTextH^^.txFont := currentFont;
		MyTextH^^.txSize := CurrentSize;
		textFont(currentFont);  {also set grafPort to this font & size}
		textSize(CurrentSize);			{to be able to read fontInfo}

		GetFontInfo(FInfo);
		with FInfo do
			begin
				MyTextH^^.lineheight := ascent + descent + leading;
				LogTextLineHeight := MyTextH^^.lineheight;
				MyTextH^^.fontascent := ascent;
			end;
		for i := 1 to LogLine do
			WriteToWindow(LogText^^[i]);
		LinesInWin := roundtol((textRect.bottom - textRect.top) / MyTextH^^.lineheight) - 1; {fits on page,1 overlap }

		logTxtMin := 1;
		logTxtPos := 1;
		logTxtMax := MyTextH^^.nLines - linesInWin + 1;
		ScrollCtrl := NewControl(LogWindow, scrollRect, '', true, logTxtPos, logTxtMin, logTxtMax, scrollBarProc, ScrollCtrlNo);
		disposed := false;
		drawLogThings;
		setcursor(QD.arrow);
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure openlogWin;

	begin

		Disposed := true;
		GetPort(oldPort);
		LogWindow := GetNewWindow(LogWindowID, nil, pointer(-1));
		SetPort(LogWindow);
		setWTitle(logWindow, concat(stringList(LogStrNr), ' ', DateTimeStr(1)));
		textRect := QD.ThePort^.portRect;
		scrollrect := textrect;
		scrollrect.right := scrollrect.right + 1;         {align with right edge of window}
		Scrollrect.left := Scrollrect.right - 16;         {17 pixels wide}
		Scrollrect.top := Scrollrect.top - 1;              {align with top edge of window}
		Scrollrect.bottom := Scrollrect.bottom + 1;  {and with bottom edge of window}
		textRect.right := scrollRect.left - 1; {room for scrollbar}
		insetRect(textRect, 6, 6); {bring it in}
		logWinOpen := true;
		NewLogText(currentFont, currentSize);
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure initLog;
		var
			i: integer;
	begin
		logWinVis := true;
		showlogStr := stringList(showlogWin);
		HidelogStr := stringList(hidelogWin);
		SetMenuItemText(menuList[logMenu], ShowHideLogCmd, hidelogstr);
		enableItem(menuList[logMenu], ClearlogCmd);
		LogText := logTextH(newHandle(sizeof(LogTextType)));
		if LogText = nil then
			begin
			error('[InitLog] LogTextHandle returned nil', 0, 0, false,true);
			exitToShell;
			end;
			
		{error(StringOf('Size=',sizeof(LogTextType)), 0, 0, false);}
		
		for i := 1 to maxLinesInLog do
			LogText^^[i] := '';
		LogLine := 1;
		openLogWin;
		LogSaved := true; {still empty, no need to save}
	end;

{----------------------------------------------------------------------------}
	procedure showHideLog;

	begin
		if not logwinOpen then
			openLogWin;
		if logwinVis then
			begin
				logWinVis := false;
				HideWindow(LogWindow);
				disableItem(menuList[logMenu], ClearlogCmd);
				SetMenuItemText(menuList[logMenu], ShowHideLogCmd, showlogstr);
			end
		else
			begin
				logWinVis := true;
				ShowWindow(LogWindow);
				SetMenuItemText(menuList[logMenu], ShowHideLogCmd, hidelogstr);
				enableItem(menuList[logMenu], ClearlogCmd);
				NewLogtext(currentFont, currentSize);
			end;
	end;

{--------------------------------------------------------------------------}
	procedure DoScrolling (loc: point);

		var
			whichControl: ControlHandle;
			tempTxtPos: integer;

	begin
		GlobalToLocal(Loc);                { clickLoc in local coords   }
		case FindControl(Loc, logWindow, whichControl) of
				kControlUpButtonPart: 
				if TrackControl(scrollCtrl, Loc, pointer(-1)) <> 0 then
					begin
						if logTxtPos > logTxtMin then
							begin
								logTxtPos := logTxtPos - 1;
								TEScroll(0, MyTextH^^.lineheight, MyTextH);
								SetControlValue(scrollCtrl, logTxtPos);
							end;
					end;
				kControlDownButtonPart: 
				if TrackControl(scrollCtrl, Loc, pointer(-1)) <> 0 then
					begin
						if logTxtPos < LogTxtMax then
							begin
								logTxtPos := logTxtPos + 1;
								TEScroll(0, -MyTextH^^.lineheight, MyTextH);
								SetControlValue(scrollCtrl, logTxtPos);
							end;
					end;
				kControlPageUpPart: 
				if TrackControl(scrollCtrl, Loc, pointer(-1)) <> 0 then
					begin
						logTxtPos := logTxtPos - LinesInWin;
						if logTxtPos < logTxtMin then
							begin
								TEScroll(0, (LinesInWin - (LogTxtMin - LogTxtPos)) * (MyTextH^^.lineheight), MyTextH);
								logTxtPos := logTxtMin;
							end
						else
							TEScroll(0, LinesInWin * (MyTextH^^.lineheight), MyTextH);
						SetControlValue(scrollCtrl, logTxtPos);
					end;
				kControlPageDownPart: 
				if TrackControl(scrollCtrl, Loc, pointer(-1)) <> 0 then
					begin
						logTxtPos := logTxtPos + LinesInWin;
						if logTxtPos > logTxtMax then
							begin
								TEScroll(0, -(LinesInWin - (LogTxtPos - LogTxtMax)) * (MyTextH^^.lineheight), MyTextH);
								logTxtPos := logTxtMax;
							end
						else
							TEScroll(0, -LinesInWin * (MyTextH^^.lineheight), MyTextH);
						SetControlValue(scrollCtrl, logTxtPos);
					end;
				kControlIndicatorPart: 
				if TrackControl(scrollCtrl, Loc, pointer(-1)) <> 0 then
					begin
						tempTxtPos := GetControlValue(scrollCtrl);
						if tempTXtPos < logTxtMin then
							tempTxtPos := LogTxtMin;
						if tempTXtPos > logTxtMax then
							tempTxtPos := LogTxtMax;
						TEScroll(0, ((logTxtPos - tempTxtPos) * (MyTextH^^.lineheight)), MyTextH);
						logtxtPos := tempTxtPos;
						SetControlValue(scrollCtrl, logTxtPos);
					end;
		end;{of case Findcontrol}
	end;

{----------------------------------------------------------------------------}
	procedure savelog;

		var
			i, LOGFNo: integer;
			temp: str255;

	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		if create_interactive(LOGFno, stringList(SaveLOGFasNr), itsALOGF, nil) then
			begin
				setWTitle(logWindow, GetFname(LOGFno));
				for i := 1 to LogLine do
					begin
						temp := concat(LogText^^[i], chr(13));
						if WriteLOGF(LOGFno, temp) then
				{ OK}
						else
							begin
								error(StringOf('', getfname(LOGFno), ' : '), LOGFIOerrNr, 0, false,false);
								CloseFile(LOGFno);
								setCursor(QD.arrow);
								LogSaved := false;
								setPort(oldPort);
								exit(Savelog);
							end;
					end;
				CloseFile(LOGFno);
				LogSaved := true;
				setCursor(QD.arrow);
			end;

		setPort(oldPort);
	end;

{------------------------------------------------------------------------------}
	function closeLog: boolean;

		procedure doClose;
			var
				i: integer;
		begin
			TEDispose(MyTextH);
			disposeControl(ScrollCtrl);
			disposeWindow(logWindow);
			disposed := true;
			logWinOpen := false;
			logSaved := false;
			LogLine := 1;
			for i := 1 to MaxLinesInLog do
				LogText^^[i] := '';
			disposeHandle(Handle(LogText));
		end;

	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		if not Logsaved then {give user a chance to do save}
			begin
			case askSaveLog of
				Save: 
					begin
						saveLog;
						doClose;
						closeLog := true;
					end;
				Cancel: 
					closeLog := false;
				DontSave: 
					begin
						doClose;
						LogSaved := false;
						closeLog := true;
					end;
				end; {case}
			end
		else {log was saved}
			begin
			doClose;
			closeLog := true;
			end;
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure clearlog;

		procedure doClear;
			var
				i: integer;
		begin
			TESetSelect(0, 32767, MyTextH);
			TECut(MyTextH);
			for i := 1 to LogLine do
				LogText^^[i] := '';
			LogLine := 1;
			setWTitle(logWindow, concat(stringList(LogStrNr), ' ', DateTimeStr(1)));
		end;

	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		if not Logsaved then
			case askSaveLog of
				Save: 
					begin
						saveLog;
						doClear;
						LogSaved := true; 
					end;
				Cancel: 
					; {do nothing}
				DontSave: 
					begin
						doClear;
						LogSaved := true; {no use in saving a cleared log}
					end;
			end {case}
		else  {log was saved & unchanged}
			DoClear;
		drawLogThings;
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure OpenlogFile;

		var
			LOGFNo: integer;
			temp: str255;

	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		ClearLog;
		setcursor(getcursor(watchcursor)^^);
		LOGFno := itsaLOGF; {tell open_interactive it's a log file}
		if open_interactive(LOGFno, nil) then
			begin
				setWTitle(logWindow, GetFname(LOGFno));
				reset(LOGFno);
				LogLine := 0;
				while readLine(LOGFno, temp) do
					begin
						LogLine := LogLine + 1;
						LogText^^[LogLine] := copy(temp, 1, length(temp));
						if LogLine = maxLinesInLog - 1 then  {-1 to cater for 'Log Full' message}
							begin
								Error(stringList(logFullNr), 0, 0, false,false);
								logLine := LogLine + 1; {once to force logline>maxlinesinLog}
								LogText^^[LogLine] := stringList(logFullNr);
								WriteToWindow(LogText^^[LogLine]);
								CloseFile(LOGFno);
								setCursor(QD.arrow);
								NewLogText(currentFont, currentSize);
								setPort(oldPort);
								exit(OpenLogFile);
							end;
					end; {while not EOF }
				CloseFile(LOGFno);
				setCursor(QD.arrow);
			end; {if open}
		NewLogText(currentFont, currentSize);
		setPort(oldPort);
	end;
	
	
{----------------------------------------------------------------------------}
	procedure updateLogWindow;
	
	begin
		GetPort(oldPort);
		setPort(logwindow);
		DrawlogThings; {in unit log}
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure writeLog (message: str80);

	begin
		GetPort(oldPort);
		setPort(LogWindow);
		LogSaved := false;
		if LogLine = maxLinesInLog - 1 then  {-1 to cater for 'Log Full' message}
			begin
				Error(stringList(logFullNr), 0, 0, false,false);
				logLine := LogLine + 1; {once to force logline>maxlinesinLog}
				LogText^^[LogLine] := stringlist(logFullNr);
			end
		else if LogLine >= maxLinesInLog then
	  {dont log}
		else
			begin
				logLine := LogLine + 1;
				LogText^^[LogLine] := message;
			end;
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
end. {of unit log}