program main;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{ 	Version 1.2.0  -  Changes Programmed by B.J. Kbben, 21-08-92  :                          }
{ 	                          - Moved About.. proc. to unit Splash & combined with splash proc.   }
{ Version 2.0:    - numerous new functions; demo mode, log and edit menus, jan-dec 93 }
{ Version 2.1:	- Cleaned up Handle allocation checking - 3/94								}
{						- Bug Fix: inits eenheid first time running - 3/94						}
{						- SetUp now in one Resource & Handle- 8/94						
		Version 2.2OS - code and app made OpenSource July 2002 BJK	}
{ ########################################################}

	uses
		{UIP}
			QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,processes,devices,events,
			Dialogs,Types,TextEdit,TextUtils,toolutils,OSutils,resources,Printing,QDOffscreen,
			GestaltEqu,EPPC,files,
		{MyUnits}
			myPrint, globals, ErrorsAndBeeps, log, myFiles, myFonts, Scale, convert, splash, 
			myWindows, tables, setUp, license, info,showhelp,DSUtils,DSUserProcs,DSAppleEvents;

	var
		dump: boolean;
		dragRect: rect;
		DlogItem:integer;

{------------------------------------------------------------}
	procedure initsystem;

	const
		LightBluePatID = 128;
		DarkGrayPatID = 129;
		DarkBluePatID = 130;
		WhitePatID = 131;
		RedPatID = 132;
		BackPatID = 133;
		
	var
		i, resErr: byte;
		aLong:longInt;

	begin
		InitGraf(@QD.thePort);
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(nil);
		InitCursor;
		MaxApplZone;
		MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;
		MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;
		MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;	MoreMasters;
		
		doBackground := false; {}
		autoAnswer := true; {}
		OneDone := false;
		logWinOpen := false;
		InfoOnly := false;
		Finished := False;
		LicenseTried := false;		
		DXFlineNr := 0; {global var declared in MyFiles}
		ProgressWinInited := false;
		DrwWinInited := false;
		
		setcursor(getcursor(watchcursor)^^);
		
		{DropShell stuff:}
		gHasAppleEvents := (Gestalt(gestaltAppleEventsAttr, aLong) = noErr);
		if (not gHasAppleEvents) then
				Error('', NoAEMAnagerNr, 0, true,false);
		InitAEVTStuff;
					
		with QD.screenbits.bounds do
			setrect(dragRect, 4, 24, right - 4, bottom - 4);
		
		InitError; {in unit ErrorsAndBeeps}
		
		LightBluePat:= GetPixPat(LightBluePatID);
		DarkGrayPat:= GetPixPat(DarkGrayPatID);
		DarkBluePat:= GetPixPat(DarkBluePatID);
		WhitePat:= GetPixPat(WhitePatID);
		RedPat:= GetPixPat(RedPatID);
		BackGreyPat:= GetPixPat(BackPatID);
		if (LightBluePat=nil) or (DarkGrayPat=nil) or (DarkBluePat=nil) or (WhitePat=nil) or (RedPat=nil) or (BackGreyPat=nil) then
			begin
			error(stringOf('[GetPixPat] '), OutOfMemNr, 0, false,true);
			exitToShell;
			end;	
			
		SetUp := SetUpHandle(NewHandle(SizeOf(SetupRecord)));
		if SetUp = nil then
			begin
				error(stringOf('[InitSystem] No memory for Setup Record.', chr(13)), OutOfMemNr, 0, false,true);
				exitToShell;
			end;
		Hlock(Handle(Setup));

		SetupResource := SetupHandle(GetResource('stup', StupID));
		resErr := ResError;
		if SetupResource = nil then {setup doesnt exist: create and init it}
			begin
				error('[InitSystem] Setup Resource corrupted, will create new one.', 0, 0, false,false);
				SetupResource := SetupHandle(NewHandle(sizeOf(SetUpRecord)));
				if SetupResource = nil then
					begin
						error('[InitSystem] No memory for Setup Record.', OutOfMemNr, 0, false,true);
						exitToShell;
					end;
				HLock(Handle(SetupResource));
				with setUpResource^^ do
					begin
						TargetAppl := Ill11;
						Grouping := none;
						Fontsubstitution := false;
						Colorsubstitution := false;
						Lineweightsubstitution := true;
						LicenseName := 'NOT LICENSED!';
						LicenseNum := 0;
						ConverterStamp := false;
						Scaling := ToA4tall;
						CustomScale := 1;
						UseMargins := true;
						Tielines := false;
						FillSolid := true;
						FillCircle := false;
						FillPoly := false;
						GroupBlocks := false;
						VerboseLogging := false; 
						for i := 1 to maxnumFonts do
							begin
								FontTable[i] := '\';
								ColorTable[i] := '\';
								LineWeightTable[i] := '\';{now defunct}
							end;
					end;
				AddResource(Handle(SetUpResource), 'stup', stupID, 'SetUp');
				resErr := ResError;
				if resErr <> 0 then
					begin
						error('FATAL ERROR [InitSystem] Cannot add Setup resource.', ResCorruptNr, 0, false,false);
						exitToShell;
					end;
				writeResource(Handle(SetUpResource));
				resErr := ResError;
				if resErr <> 0 then
					begin
						error('FATAL ERROR [InitSystem] Cannot write Setup resource.', ResCorruptNr, 0, false,false);
						exitToShell;
					end;
			end
		else {if Getresource <> nil}
			begin
				HLock(Handle(SetupResource));
			end;

		SetUp^^ := SetUpResource^^;
		{}HLock(Handle(Setup));

		doSplash(asSplash);
		
		Eenheid := mm;			{Bug fix 3/94}
		eenheidStr := ' mm';	{Bug fix 3/94}

		prRecHdl := THPrint(NewHandle(SizeOf(TPrint))); {initing the printer record}
		if prRecHdl=nil then
			begin 
			error(stringOf('[InitSystem] Cannot allocate prRecHdl.', chr(13)),OutOfMemNr, 0, false,true);
			exitToShell;
			end;

		MenuList[AppleMenu] := GetMenu(AppleMenuID);{ read menus in from resource fork  }
		AppendResMenu(GetMenu(AppleMenuID), 'DRVR');  { pull in all desk accessories      }
		MenuList[FileMenu] := GetMenu(FileMenuID);
		MenuList[EditMenu] := GetMenu(EditMenuID);
		MenuList[LogMenu] := GetMenu(LogMenuID);
		MenuList[eenhedenMenu] := GetMenu(eenhedenPopupID);
		EenhedenMenuID := MenuList[eenhedenMenu]^^.menuID;
		initFontMenus; {in unit myFonts}
		MenuList[ModeMenu] := GetMenu(ModeMenuID);
		
		InsertMenu(MenuList[AppleMenu], 0);
		InsertMenu(MenuList[FileMenu], 0);
		InsertMenu(MenuList[EditMenu], 0);
		InsertMenu(menuList[logMenu], 0);
		InsertMenu(menuList[ModeMenu], 0);
		InsertMenu(menuList[FontMenu], -1);
		InsertMenu(menuList[FontSizeMenu], -1);
		DrawMenuBar;                      { draw updated menu bar to screen   }
		initShowHelp; {in unit ShowHelp}
		InitTimedDialog;  {in unit ErrorsAndBeeps}
		
		
	end; { of initsystem}

{------------------------------------------------------------}
	procedure DoDeskAcc (Item: Integer);
{}
{    purpose         start up desk accessory from Apple menu}
{}
		var
			SavePort: GrafPtr;
			RefNum: Integer;
			DName: str255;
	begin
		GetPort(SavePort);                    { save port before starting it  }
		GetMenuItemText(MenuList[AppleMenu], Item, DName);     { get name of desk accessory    }
		refNum := OpenDeskAcc(DName);         { and start that sucker up!     }
		SetPort(SavePort);                    { restore grafport and continue }
	end; { of proc DoDeskAcc }


{----------------------------------------------------------------------------}
	procedure DoEdit (whichWindow: WindowPtr; item: integer);

	begin
		case item of
			UndoCmd: 
				;  {should't be possible}
			CutCmd: 
				DialogCut(whichWindow); {only possible in Dialogs }
			CopyCmd: 
				DialogCopy(whichWindow);{only possible in Dialogs }
			PasteCmd: 
				DialogPaste(whichWindow);{only possible in Dialogs }
			ClearCmd: 
				DialogDelete(whichWindow);{only possible in Dialogs }
		end;
	end;

{----------------------------------------------------------------------------}
	procedure HandleMenu (MenuInfo: LongInt);

		
		var
			Menu: Integer;          { menu number that was selected     }
			Item: Integer;          { item in menu that was selected    }
			
	begin
		if MenuInfo <> 0 then
			begin
				PenNormal;                      { set the pen back to normal        }
				Menu := HiWord(MenuInfo);       { find which menu the command is in }
				Item := LoWord(MenuInfo);       { get the command number            }
				case Menu of                    { and carry it out                  }
					AppleMenuID: 
						begin
							if Item = 1 then
								DoSplash(asAboutBox)            { bring up "About..." window (24/08: in unit splash- BJK)}
							else
								DoDeskAcc(Item);   { start desk accessory      }
							HiliteMenu(0);
						end;
					FileMenuID: 
						case Item of
							TranslateCmd: 
								begin
								doConvert(nil);{in unit convert}
								end;
							InfoCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									CollectInfo(normal);
									HiliteMenu(0);
								end;
							SetupCmd: 
								begin
									if BitAnd(TheEvent.modifiers, optionKey) <> 0 then
										VoerLicenseIn {in unit License}
									else
										begin
											if ThisIsdemo then
												doSplash(asSplash);
											DoSetUp; { in unit Setup}
										end;
									HiliteMenu(0);
								end;
							QuitCmd: 
								begin
								if ThisIsdemo then
									doSplash(asSplash);
								QuitApp; {in unit DSUserProcs}
								end; {QuitCmd}
							end; {case Item}
					EditMenuID: 
						begin
							if ThisIsdemo then
								doSplash(asSplash);
							DoEdit(frontWindow, item);
							HiliteMenu(0);
						end;
					LogMenuID: 
						case item of
							ShowHideLogCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									ShowHideLog; {in unit log}
									HiliteMenu(0);
								end;
							ClearLogCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									ClearLog; {in unit log}
									HiliteMenu(0);
								end;
							OpenLogCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									openLogFile; {in unit log}
									HiliteMenu(0);
								end;
							SaveLogCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									SaveLog; {in unit log}
									HiliteMenu(0);
								end;
							PageSetupCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									Paginainstelling; {in unit myPrint}
									HiliteMenu(0);
								end;
							PrintLogCmd: 
								begin
									if ThisIsdemo then
										doSplash(asSplash);
									Print;  {in unit MyPrint}
									HiliteMenu(0);
								end;
						end;{case item of}
					ModeMenuID :
						begin
							case Item of
								FastModeCmd:
									begin
									SetItemMark(MenuList[ModeMenu], FastModeCmd, chr(diamondMark));
									SetItemMark(MenuList[ModeMenu], BackgroundModeCmd, chr(noMark));
									doBackGround := false;
									end;
								BackgroundModeCmd:
									begin
									SetItemMark(MenuList[ModeMenu], FastModeCmd, chr(noMark));
									SetItemMark(MenuList[ModeMenu], BackgroundModeCmd, chr(diamondMark));
									doBackGround := true;
									end;
								AutoAnswerCmd:
									begin
									if AutoAnswer then
										begin
										SetItemMark(MenuList[ModeMenu], AutoAnswerCmd, chr(noMark));
										AutoAnswer := false;
										end
									else
										begin
										SetItemMark(MenuList[ModeMenu], AutoAnswerCmd, chr(checkMark));
										AutoAnswer := true;
										end;
									end;
							end;{case}
							HiliteMenu(0);
						end;
					FontMenuID: 
						begin
							changeFont(item);{in unit font}
							HiliteMenu(0);
						end;
					FontSizeMenuID: 
						begin
							changeFontSize(item);{in unit font}
							HiliteMenu(0);
						end;
				end;{case MenuOf}
			end;
	end;

{------------------------------------------------------------}
	procedure DoMouseDown (theEvent: EventRecord);
{}
{    purpose         identify where mouse was clicked and handle it}
{}
		var
			theWindow: WindowPtr;
			MLoc: Point;
			WLoc: Integer;

	begin
		MLoc := theEvent.Where;              { get mouse position in global coords   }
		WLoc := FindWindow(MLoc, theWindow);   { get window, loc in window     }
		case WLoc of                          { handle window locations       }
			InMenuBar: 
				HandleMenu(MenuSelect(MLoc));     { in the menu       }
			InSysWindow: 
				SystemClick(theEvent, theWindow);  { in a DA window    }
			inDrag: 
				DragWindow(theWindow, theEvent.where, dragRect);
			inGoAway: 
				if trackGoAway(theWindow, theEvent.where) then {hilite goAway & check}
					if theWindow = LogWindow then
						ShowHideLog;
			inContent: 
				begin
					if (theWindow = LogWindow) and (logwindow = frontwindow) then
						doScrolling(Mloc); {in unit log}
						{}
					if (theWindow = LogWindow) and (logwindow <> frontwindow) then
						BringToFront(logwindow);
						{}
				end;
		end; {of case WLoc}
	end; { of proc DoMouseDown }

{------------------------------------------------------------}
	procedure DoKeypress (theEvent: EventRecord);
{}
{    purpose         handles keypress (keyDown, autoKey) event}
{}
		var
			KeyCh: Char;
	begin
		if (bitand(theEvent.modifiers, cmdKey)) <> 0 then
			begin { menu key command }
				KeyCh := Chr(bitand(theEvent.Message, charCodeMask)); { decode character }
				HandleMenu(MenuKey(KeyCh))                       { get menu and item}
			end
		else
			begin
			end;
	end; { of proc DoKeypress }


{------------------------------------------------------------}
	procedure HandleEvent (theEvent: EventRecord);


		
	begin
		case theEvent.What of
			kHighLevelEvent: 
				DoHighLevelEvent(theEvent); {in unit DSAppleEvents}
			mouseDown: 
				DoMouseDown(theEvent);      { mouse button pushed   }
			keyDown: 
				DoKeyPress(theEvent);       { key pressed down      }
			updateEvt: 
				begin
					if (windowPtr(theEvent.message) = logWindow) then
						begin
						BeginUpdate(WindowPtr(theEvent.message));
						UpdateLogWindow; {in unit log}
						EndUpdate(WindowPtr(theEvent.message));
						end;
				end;
			otherwise
				;
		end;{case}
	end; { of proc HandleEvent }
	
	{----------------------------------------------------------------------------}
	procedure DealWithDlog(theEvent: EventRecord);

	var
		dump: boolean;
		DlogItem: integer;
		KeyCh: Char;
		theWindow: WindowPtr;
		MLoc: Point;
		WLoc: Integer;

		
	begin
		MLoc := theEvent.Where;              { get mouse position in global coords   }
		WLoc := FindWindow(MLoc, theWindow);
		case theEvent.what of
			mouseDown: 
				begin
					dump := DialogSelect(theEvent, WindowPtr(theEvent.message), DlogItem);
				end;
			keyDown, autoKey: {key-event}
				begin
					KeyCh := Chr(bitand(theEvent.Message, charCodeMask));
					if bitAnd(theEvent.modifiers, cmdKey) <> 0 then
						begin {command-key}
							HandleMenu(MenuKey(KeyCh)) ;
						end
					else
						begin
						end;
				end;
			otherwise
				;
		end; {case}
	end; {procedure}

{------------------------------------------------------------}
{-------------------- MAINLOOP -----------------------------}
{------------------------------------------------------------}

begin
	{ removed: IOCheck(False) 2.2 - 9/96}
	initsystem;
	initLog; {in unit Log}
	SetCursor(QD.arrow);
	repeat   { keep doing the following  }  			
		if WaitNextEvent(EveryEvent, theEvent,10,nil) then		
			begin {there is an Event}
				if isDialogEvent(theEvent) then
					DealWithDlog(theEvent) {it's a DialogEvent}
				else
					HandleEvent(theEvent); {it's another Event}
			end
		else {no event,but call this anyway for caret-blinking, mouse-changing, etc.}
			begin
				if isDialogEvent(theEvent) then
					dump := DialogSelect(theEvent, WindowPtr(theEvent.message), DlogItem);
			end;
	until Finished;                          { until user is done        }
	
	
	
	HUnlock(Handle(Setup));
	HUnlock(Handle(SetUpresource));
	DisposeHandle(Handle(setUp));
	ReleaseResource(Handle(setUpResource));
end.