unit myFiles;


{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                        	    }
{ 	Version 2.0    -  Changes Programmed by B.J. Kbben                							    }
{								- Font TAble file reads & writes, 11-93										}
{					Bug fix - (readgroup) code=999 if not recognised- 1-94							}
{								- (readgroup) recognise XDATA -1-94											}
{ ########################################################}
{ 	Version 2.1    -  Changes Programmed by B.J. Kbben                							    }
{						- Write&readTable discarded, Write & Read Setup Instead	- 8/94			}
{						- readGroup now has a Why for reading Colors	- 9/94							}
{ ########################################################}
{ Version 2.2 - Changes programmed by B.J. Kbben	summer/fall 1996				}
{Changed all calls to UIP calls (FS*** calls). Makes us 7.x dependent, but what the heck...
Introduced unit IO.p (and IO.rsrc) for opening and closing files.
Removed unused routines: 
- append
- rewrite
- fcreate
- open
Removed unused boolean from parameters of procedure CloseFile.
Restructured filerec. Now contains FSReply (standardFileReply, containing vrefnum, name, etc).
		Version 2.2OS - code and app made OpenSource July 2002 BJK
########################################################}


interface


	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,events,
	Dialogs,Types,TextEdit,TextUtils,Processes,files,standardfile,
	{MyUnits}
		IO,globals, ErrorsAndBeeps, log, myWindows;
		
	const
		REALTP = 1;
		INTEGRTP = 2;
		STRINGTP = 4;
		SPECIALTP = 8;
		LONGINTTP = 10;
		
	type
		strtype = string;
		strptr = ^strtype;

		grouptype = record
				code: integer;
				datatype: integer;
				intdat: integer;
				longintdat :longint;
				realdat: real;
				strdat: strptr;
			end;

	var
		DxfFileNo: Integer;
		IllFileNo: Integer;
		
	procedure copygroup (source: grouptype; var target: grouptype);
	function open_interactive (var fileno: integer; droppedFileSpecs: FSSpecPtr): boolean;
	function create_interactive (var fileno: integer; prompt: string; suggno: integer;droppedFileSpecs: FSSpecPtr): boolean;
	function readline (fileno: integer; var nwstring: string): boolean;
	function writeSetupFile (fileno: integer; theSetUp: SetUprecord): boolean;
	function readSetUpFile (fileno: integer; var theSetUp: SetUprecord): boolean;
	function writeLOGF (fileno: integer; Str: str255): boolean;
	function writestring (fileno: integer; str: string): boolean;
	function writelnstring (fileno: integer; str: string): boolean;
	procedure CloseFile (fileno: integer);
	procedure closeallfiles;
	procedure reset (fileno: integer);
	function getfname (fileno: integer): string;
	function readgroup (var group: grouptype; why: reason): boolean; { read from current input file }
	function setinput (fileid: integer): boolean; { set current input file }
	function getregno: string; { regno of current input file }
	function infilename: string; { name of current input file }
	function openfiles(droppedFileSpecs: FSSpecPtr): boolean;
	function GetFilePos: Longint;
	procedure SetFilePos (NwPos: Longint);
	function FileSize (FileNo: integer): Longint;

implementation
	const
		bufsize = 10000;
		MaxFiles = 10;

	type
		memblock = packed array[1..bufsize] of byte;
		memptr = ^memblock;
		filerec = record
				frefnum: integer;
				ThisFileSpecs : FSSpec; {instead of vrefnum: contains ao the name in .name}
				input: boolean;
				open: boolean;
				data: memptr;
				endbuf, curpos, filepos, fsize: longint;
				regno: longint;
			end;


	procedure SetNewLayer (LayerName: NameString);
	external;
	procedure SetNewLType (LTypeName: NameString);
	external;
	procedure SetNewColor (ColorNum: Integer);
	external;

	var
		filelist: array[1..MaxFiles] of filerec;
		started: boolean;
		readfile: integer;
		
		moment: Longint;
		Globeid: integer;

	var
		LogFileName: string;


{----------------------------------------------------------------------------}
	procedure copygroup;
	begin
		target := source;
		with target do
			begin
				if source.datatype = STRINGTP then
					begin
					
						if not MemAvail(sizeof(strtype)) then 
							Error('[copyGroup] ', OutOfMemNr, 0, true,true);
						strdat := strptr(newPtr(sizeof(strtype)));
						
						strdat^ := source.strdat^;
					end
				else
					strdat := nil;
			end;
	end;

{----------------------------------------------------------------------------}
	procedure startup;
		var
			tel: integer;
	begin
		aborted := false;
		moment := TickCount;
		Globeid := 0;
		ReadFile := -1;
		for tel := 1 to MaxFiles do
			filelist[tel].open := false;
		started := true;
	end;

{----------------------------------------------------------------------------}
	function getfreefilerec: integer;
		var
			tel: integer;
	begin
		tel := 1;
		while (tel < MaxFiles) and (filelist[tel].open) do
			tel := tel + 1;
		if tel < MaxFiles then
			getfreefilerec := tel
		else
			getfreefilerec := 0;
	end;


{----------------------------------------------------------------------------}
	function open_interactive (var fileno: integer;droppedFileSpecs: FSSpecPtr): boolean;
	
		var
			reply: standardFileReply;
			Filter: OSType;
			IO_FileRefNum:integer;
			
	begin
		if not started then
			startup;
		open_interactive := false;
		case fileno of
			itsSTUP: 
				Filter := 'STUP';
			itsaLOGF: 
				Filter := 'TEXT';
			otherwise
				Filter := '_ALL';
		end;{case}
		fileno := getfreefilerec;
		if fileno > 0 then
				begin
				if IO_OpenReadFile(IO_FileRefNum,Reply, Filter,fsRDPerm,droppedFileSpecs) then
					begin
						with filelist[fileno] do
							begin
							frefnum := IO_FileRefNum;		
							if droppedFileSpecs = nil then {opened by menu}
								ThisFileSpecs := Reply.sfFile
							else {dropped on me}
								ThisFileSpecs := droppedFileSpecs^;
							open := true;
							input := true;
							
							if not MemAvail(sizeof(memblock)) then 
								Error('[open_interactive] ', OutOfMemNr, 0, true,true);
							data := memptr(newPtr(sizeof(memblock)));
						
							endbuf := 0;
							curpos := 1;
							regno := 0;
							filepos := 0;
							end; {with}
						open_interactive := true;
					end; {if IO_Open}
				end; {if fileno...}
	end;


{----------------------------------------------------------------------------}
	function create_interactive (var fileno: integer; prompt: string; suggno: integer;droppedFileSpecs: FSSpecPtr): boolean;
		
		var
			OutFileName, logName: str255;
			creator, filetype: OSType;
			IO_FileRefNum:integer;
			reply: standardFileReply;
	
	begin
		if not started then
			startup;
		create_interactive := false;
		outFileName := '';
		logName := '';
		fileno := getfreefilerec;
		if fileno > 0 then
			begin
				if (suggno < itsaLOGF) then {illustrator file}
					begin
						creator := 'ARTY';
						filetype := 'TEXT';
						with filelist[suggno] do
							begin
								if (pos('.', ThisFileSpecs.name) <> 0) then
									outfilename := concat(copy(ThisFileSpecs.name, 1, pos('.', ThisFileSpecs.name) - 1), '.ai')
								else
									OutFileName := concat(ThisFileSpecs.name, '.ai');
								if ThisFileSpecs.name = OutFileName then
									OutFileName := 'DxfOut.ai';
								end; {with}
					end {if..then..}
				else {StUp or LOG file}
					begin
						case suggno of
							itsSTUP: 
								begin 
								OutFileName := 'Setup File';
								creator := 'DXIL';
								filetype := 'STUP';
								end;
							itsaLOGF: 
								begin
								GetWTitle(logWindow, logName);
								OutFileName := logName;
								creator := 'DXIL';
								filetype := 'TEXT';
								end;
						end;{case}
					end; {else...}
					if droppedFileSpecs <> nil then droppedFileSpecs^.name := OutFileName;
					if IO_OpenWriteFile(IO_FileRefNum,Reply,Creator, FileType, prompt,OutFileName,fsRdWrPerm,droppedFileSpecs) then
						begin 
						with filelist[fileno] do
							begin
							frefnum := IO_FileRefNum;	
							if droppedFileSpecs = nil then {opened by menu}
								ThisFileSpecs := Reply.sfFile
							else {dropped on me}
								ThisFileSpecs := droppedFileSpecs^;
							open := true;
							input := false;
							
							if not MemAvail(sizeof(memblock)) then 
								Error('[create_interactive] ', OutOfMemNr, 0, true,true);
							data := memptr(newPtr(sizeof(memblock)));
							
							endbuf := 0;
							filepos := 0;
							curpos := 1;
							regno := 0;
							end;
						create_interactive := true;
						end;
			end; {if fileno>0}
	end; {function create_interactive}
	
{----------------------------------------------------------------------------}
	procedure fillbuf (filno: integer);
		var
			result: OSErr;
	begin
		with filelist[filno] do
			begin
				endbuf := sizeof(data^);
				result := FsRead(frefnum, endbuf, ptr(data));
				filePos := filePos + endbuf;
				curpos := 1;
				if (endbuf = 0) then {eof}
					begin
					data^[curpos] := 0;
					if not EOFencountered then {no need to warn again}
						begin
						error(stringOf(stringlist(UnexpectedEOFnr),' (Expecting ',WaitingForStr,')'),0, DXFlineNr,true,false);
						EOFencountered := true;
						end;
					end;
			end;
	end;

{----------------------------------------------------------------------------}
	function readline (fileno: integer; var nwstring: string): boolean;
		var
			strtel: byte;
			ch: integer;
	begin
		if TickCount - Moment > 60 then
			begin
				GlobeId := GlobeId + 1;
				if GlobeId > 6 then
					GlobeId := 0;
				setcursor(getcursor(GlobeCursorId + GlobeId)^^);
				moment := TickCount;
			end;
		readline := false;
		if EOFencountered then 
			exit(readline);
		nwstring := '';
		strtel := 1;
		if started then
			with filelist[fileno] do
				if open then
					begin
						repeat
							if curpos > endbuf then {data^ leeg}
								fillbuf(fileno);
							if EOFencountered then 
								exit(readline);
							ch := data^[curpos];
							curpos := curpos + 1;
							if ch > 31 then
								begin
									nwstring[strtel] := char(ch);
									strtel := strtel + 1;
								end;
						until (ch = 10) or (ch = 13) or (strtel > 255);
						
						nwstring[0] := char(strtel - 1);
						if (ch = 0) and (nwstring = '') then
							exit(readline);
						readline := True;
						DXFlineNr:=DXFLineNr+1;
						regno := regno + 1;
						if (ch = 13) then
							begin
								if (curpos > endbuf) and (nwstring <> 'EOF') then {data^ leeg, not yet EOF}
									fillbuf(fileno);							
								if EOFencountered then 
									exit(readline);
								if data^[curpos] = 10 then {ignore newline}
									curpos := curpos + 1;
							end;
					end;
	end;

{----------------------------------------------------------------------------}
	function writeSetupFile (fileno: integer; theSetUp: SetUprecord): boolean;
		var
			result: OSErr;
			len: longint;
			tempPtr: SetupPtr;
	begin
		len := sizeOf(Setuprecord);
		if not MemAvail(len) then 
			Error('[writeSetupFile] ', OutOfMemNr, 0, true,true);
		tempPtr := SetUpPtr(newPtr(len));
		with filelist[fileno] do
			begin
				tempPtr^ := theSetUp;
				result := FSWrite(frefnum, len, Ptr(tempPtr));
				if result = 0 then
					begin
						writeSetupFile := true;
					end
				else
					writeSetupFile := false;
			end;
		DisposePtr(Ptr(tempPtr));
	end;

{----------------------------------------------------------------------------}
	function readSetUpFile (fileno: integer; var theSetUp: SetUprecord): boolean;
		var
			result: OSErr;
			len, normallen: longint;
			tempPtr: Ptr;
	begin
		normallen := sizeOf(Setuprecord);
		len := sizeOf(Setuprecord);
		if not MemAvail(len) then 
			Error('[readSetupFile] ', OutOfMemNr, 0, true,true);
		tempPtr := newPtr(len);
		with filelist[fileno] do
			begin
				result := FsRead(frefnum, len, ptr(tempPtr));
				if (len = normallen) and (result = 0) then
					begin
						readSetupFile := true;
						theSetUp := setUpPtr(TempPtr)^;
					end
				else
					begin
						readSetupFile := false;
					end;
			end;
		DisposePtr(tempPtr);
	end;

{----------------------------------------------------------------------------}
	function writeLOGF (fileno: integer; Str: str255): boolean;
		var
			result: OSErr;
			len: longint;
			i: byte;
	begin
		len := length(str);
		with filelist[fileno] do
			begin
				for i := 1 to len do
					begin
						data^[i] := byte(str[i]);
						curpos := curpos + 1;
					end;
				result := FSWrite(frefnum, len, Ptr(data));
				if result = 0 then
					begin
						writeLOGF := true;
					end
				else
					writeLOGF := false;
			end;
	end;

{----------------------------------------------------------------------------}
	function writestring;
		var
			strtel, len: integer;
			result: OSErr;
			count: longint;
	begin
		if TickCount - moment > 30 then
			begin
				GlobeId := GlobeId + 1;
				if GlobeId > 6 then
					GlobeId := 0;
				setcursor(getcursor(GlobeCursorId + GlobeId)^^);
				moment := TickCount;
			end;
		writestring := false;
		if started then
			with filelist[fileno] do
				if open then
					if not input then
						begin
							len := byte(str[0]);
							writestring := true;
							strtel := 1;
							while strtel <= len do
								begin
									if curpos > sizeof(data^) then
										begin
											count := curpos - 1;
											result := fswrite(frefnum, count, ptr(data));
											if (result <> 0) then
												writestring := false
											else
												FilePos := FilePos + sizeof(data^);
											curpos := 1;
										end;
									data^[curpos] := byte(str[strtel]);
									if data^[curpos] = 13 then
										regno := regno + 1;
									strtel := strtel + 1;
									curpos := curpos + 1;
								end;
						end;
	end;

{----------------------------------------------------------------------------}
	function writelnstring;
	begin
		if writestring(fileno, str) then
			;
		writelnstring := writestring(fileno, chr(13));
	end;

{----------------------------------------------------------------------------}
	procedure CloseFile (fileno: integer);
		var
			result: OSErr;
	begin
		setcursor(QD.arrow);
		if filelist[fileno].open then
			with filelist[fileno] do
				begin
					if not input then
						begin
							curpos := curpos - 1;
							result := fswrite(frefnum, curpos, ptr(data));
						end;
					IO_CloseFile(frefnum,ThisFileSpecs);
					open := false;
					if data <> nil then disposePtr(Ptr(data));
				end;
	end;

{----------------------------------------------------------------------------}
	procedure closeallfiles;
		var
			tel: integer;
	begin
		if started then
			begin
				tel := 1;
				while (tel < MaxFiles) do
					begin
						CloseFile(tel);
						tel := tel + 1;
					end;
			end;
	end;

{----------------------------------------------------------------------------}
	procedure reset(fileno: integer);
		var
			result: OSErr;
	begin
		if not started then
			startup;
		with filelist[fileno] do
			begin
				if input then
					begin
						result := SetFPos(frefnum, FsFromStart, 0);
						curpos := endbuf + 1;
						regno := 0;
						FilePos := 0;
					end;
			end;
	end;

{----------------------------------------------------------------------------}
	function getfname;
	begin
		getfname := '';
		if not started then
			startup;
		with filelist[fileno] do
			begin
				if open then
					getfname := ThisFileSpecs.name;
			end;
	end;


{----------------------------------------------------------------------------}
	function readgroup (var group: grouptype; why: reason): boolean;
	
		var
			regel: string;
			result: integer;
			
	begin
		readgroup := false;
		if not aborted then
			CheckAbort;
		if aborted then
			exit(ReadGroup);
		
		repeat {until code <9999}
			readgroup := false;
			with group do
				begin
					if readline(readfile, regel) then
						begin
							readstring(regel, code);
							
							result := ioresult;
							if readline(readfile, regel) then
								begin
									if ioresult = 0 then
										begin
										case code of
											6: 
												datatype := SPECIALTP;
											8: 
												datatype := SPECIALTP;
											0..5, 7, 9,100,102,105,300..369,999:  
												begin
													datatype := STRINGTP;
												end;
											10..59,140..147,210,220,230: 
												begin
													datatype := REALTP;
												end;
											62: { 62 : colornum }
												begin
													if why = getColors then
														datatype := INTEGRTP
													else
														datatype := SPECIALTP;
												end;
											60, 61, 63..79,170..175,280..289: 
												begin
													datatype := INTEGRTP;
												end;
											90..99:
												begin
												datatype := LONGINTTP;
												end;
											1000..1071: {X-DATA, AutoCad release 11}
												begin
													datatype := STRINGTP;
													regel := 'XDATA'; {to flag for readentities}
												end;
											otherwise {unknown codes-should not happen!}
												begin
													datatype := STRINGTP;
													{don't warn here, will deal with them in supported entities if used there!}
												end;
										end;{case code}
									case datatype of
										STRINGTP: 
											begin
												if strdat = nil then
													begin
													if not MemAvail(sizeof(strtype)) then 
														Error('[ReadGroup] ', OutOfMemNr, 0, true,true);
													strdat := strptr(newPtr(sizeof(strtype)));
													end;
												strdat^ := regel;
												readgroup := True;
											end;
										REALTP: 
											begin
												readstring(regel, realdat);
												if ioresult = 0 then
													readgroup := True;
											end;
										INTEGRTP: 
											begin
												readstring(regel, intdat);
												if ioresult = 0 then
													readgroup := True;
											end;
										LONGINTTP: 
											begin
												readstring(regel, longintdat);
												if ioresult = 0 then
													readgroup := True;
											end;
										SPECIALTP: 
											begin
												if (code = 8) then
													begin
														if not itsABlock then {keep blocks on one layer}
															SetNewLayer(regel);
													end
												else if code = 6 then
													begin
													SetNewLType(regel);
													end
												else if code = 62 then
													begin
													readstring(regel, result);
													SetNewColor(result);
													end;
												readgroup := True;
												code := 9999;
											end; {end Specialtype}
										end; { case datatype}
									end; {if ioresult=0}
								end; { if readline}
						end; { with code }
				end;
		
	until group.code < 9999; {to not send on the specialtp's, which are taken care of here}
	
	end; { function readgroup }

{----------------------------------------------------------------------------}
	function setinput(fileID: integer): boolean;
	begin
		setinput := false;
		if (fileID > 0) and (FileID < MaxFiles) then
			if filelist[fileID].open then
				if filelist[fileID].input then
					begin
						readfile := fileID;
						setinput := True;
					end;
	end;

{----------------------------------------------------------------------------}
	function getregno;
	begin
		getregno := stringof(filelist[readfile].regno);
	end;

{----------------------------------------------------------------------------}
	function infilename;
	begin
		infilename := filelist[readfile].ThisFileSpecs.name;
	end;

{----------------------------------------------------------------------------}
	function openfiles(droppedFileSpecs: FSSpecPtr): boolean;
		var
			IsDxfFile: boolean;
			group: grouptype;
			Cancelled: boolean;
			
	begin
		group.strdat := nil;
		IsDxfFile := False;
		Cancelled := False;
		OpenFiles := False;
		infoOnly := false;
		
			repeat
				if open_interactive(DxfFileno, droppedFileSpecs) then
					begin
					if not SetInput(DxfFileNo) then
						exit(OpenFiles);
					reset(DxfFileNo);
					DXFLineNR := 0;
					if readgroup(group, normal) then
						begin
						if group.datatype = STRINGTP then
							if group.strdat^ = 'SECTION' then
								IsDxfFile := True;
						end;
					
					if not IsDxfFile then
						begin
						if droppedFileSpecs = nil then {menu-opened -> give error message and retry} 
							Error(stringOf('',GetFName(DxfFileNo),''), NoDxfNr, 0, false,false)
						else	{dropped file -> log non DXF files, try next dropped file}
							begin
							writelog (' ');
							writelog (stringList(ConvFailedNr));
							writelog (stringOf('',GetFName(DxfFileNo),' ', stringlist(NoDxfNr)));
							end;
						CloseFile(DxfFileNo);
						DXFLineNR := 0;
						if droppedFileSpecs <> nil then Cancelled := true; {no retry for "dropped" files}
						end;
					end
				else
					Cancelled := True;
			until Cancelled or IsDxfFile;
			
			if not Cancelled then
				begin
				infoOnly := false;
				if Create_Interactive(IllFileNo, stringlist(outputFileNr), DxfFileNo, droppedFileSpecs) then
					begin
					openfiles := true;
					end;
				end;
			
		if group.strdat <> nil then
				disposePtr(Ptr(Group.strdat));
	end;


{----------------------------------------------------------------------------}
	function GetFilePos;
	begin
		with FileList[ReadFile] do
			begin
				GetFilePos := FilePos - endbuf + curpos;
			end;
	end;

{----------------------------------------------------------------------------}
	procedure SetFilePos;
	begin
		nwPos := NwPos - 1;
		with FileList[ReadFile] do
			begin
				if SetFPos(FRefNum, fsFromStart, NwPos) <> NoErr then
					;
				FilePos := NwPos;
			end;
		fillBuf(ReadFile);
	end;

{----------------------------------------------------------------------------}
	function FileSize (FileNo: integer): Longint;
	
	var
		myErr : integer;
		
	begin
		FileSize := 0;
		myErr := GetEof(filelist[fileno].frefnum, FileSize);
		if myErr <> 0 then
			begin
			Error(stringOf('[FileSize] GetEOF returned error ',myErr,'].'), 0, 0,true,false);
			exitToshell;
			end;
	end;
	

{----------------------------------------------------------------------------}
end. {of unit MyFiles}