unit myFonts;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{							- new unit, not in previous versions													}
{							- finds and handles fonts																	}
{    Version 2.0    - Programmed by B.J. Kbben-august 93												 }
{							(thanks to Freek Wiedijk for help on FOND resources)                 
		Version 2.2OS - code and app made OpenSource July 2002 BJK       	}
{ ########################################################}



interface

	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,
	Dialogs,Types,TextEdit,TextUtils,resources,QDOffscreen,
	{MyUnits}
		 globals, ErrorsAndBeeps, log, myFiles;


	procedure initFontMenus;
	function PSName (chosenFontNr: integer): str255;
	procedure changeFont (MenuItem: integer);
	procedure changeFontSize (MenuItem: integer);

implementation



	var
		fontFile: text;

{----------------------------------------------------------------------------}
	procedure initFontMenus;
	
	var
		FontsInMenu,i:integer;
		ItemNAme :str255;
	

	begin
		MenuList[FontMenu] := GetMenu(FontMenuID);
		AppendResMenu(MenuList[FontMenu], 'FOND'); { get all fonts from resources in system & open files     }
		FontsInMenu := CountMItems(menuList[FontMenu]);
		for i := 1 to FontsInMenu do
			begin
				EnableItem(menuList[FontMenu], i);
				GetMenuItemText(menuList[FontMenu], i, itemName);
				if itemName = 'Courier' then
					CourierItem := i;  {used to check Courier in Log menu}
			end;
		MenuList[fontSizeMenu] := GetMenu(fontSizeMenuID);
		currentFont := Courier; {used in log unit}
		CurrentSize := 10;
		sizeMenuSelection := 3; {pt10}
		SetItemMark(MenuList[fontSizeMenu], sizeMenuSelection, chr(checkMark));
		FontMenuSelection := CourierItem; {found in menu in initsystem, unit main}
		SetItemMark(MenuList[fontMenu], FontMenuSelection, chr(checkMark));
	end;


{----------------------------------------------------------------------------}
	function PSName (chosenFontNr: integer): str255;

		const
			SuffixBase = 11;
			StringListBase = 60;
		type
			fondFamPtr = ^FamRec;
			myArray = array[1..10000] of signedbyte;
			ArrayPtr = ^myArray;
			ArrayHandle = ^arrayPtr;
		var
			StylOff: longint;
			FontName, temp, theName: str255;
			FONDRes: Handle;
			FondArray: ArrayHandle;
			myFamRec: FamRec;
			ResSize, i, j, k, stringCount, StringLength, SuffixIndex: integer;
			stringList: array[1..20] of str32; {just a save size, normally max. 12}

	begin
		GetFontName(chosenFontNr, fontName);
		FONDRes := getARes('FOND', chosenFontNr);
		if FONDRes = nil then
			theName := ''
		else
			begin
				FONDArray := ArrayHandle(FONDRes);
				myFamRec := fondFAmPtr(FONDRes^)^;
				resSize := GetResourceSizeOnDisk(FONDRes);
				StylOff := myFamRec.ffStylOff;
				if stylOff = 0 then
					begin
						error(StringOf('', FontName, ' : '), CantFindFontNr, 0, false,false);
						theName := 'NotPS';
					end
				else
					begin
						SuffixIndex := FONDarray^^[SuffixBase + stylOff];
						stringCount := FONDarray^^[StringListBase + stylOff];
						StringLength := 0;
						k := 0;
						for j := 1 to stringCount do
							begin
								k := k + 1;
								StringLength := FONDarray^^[k + StringListBase + stylOff];
								for i := 1 to StringLength do
									temp[i] := chr(FONDarray^^[i + k + StringListBase + stylOff]);
								k := k + StringLength;
								temp[0] := chr(StringLength);
								stringList[j] := temp;
							end;
						theName := stringList[1];
						if suffixIndex > 1 then
							begin
								temp := stringList[suffixindex];
								j := ord(temp[0]);
								for i := 1 to j do
									begin
										theName := concat(theName, stringList[ord(temp[i])]);
									end;
							end;
					end;
			end;
		ReleaseResource(FONDRes);
		PSName := theName;
	end;

{----------------------------------------------------------------------------}
	procedure changeFont (MenuItem: integer);

		var
			chosenFont: str255;
			chosenFontNr: integer;
	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		SetItemMark(MenuList[fontMenu], FontMenuSelection, chr(noMark));
		GetMenuItemText(menuList[FontMenu], MenuItem, ChosenFont);
		GetFnum(ChosenFont, chosenFontNr); {check if the font can be found}
		if (chosenFontNr = 0) and (chosenFont <> 'Chicago') then
			begin
				error(StringOf('', ChosenFont, ' : '), CantFindFontNr, 0, false,false);
				chosenFontNr := currentFont; {dont change}
			end
		else
			begin
				currentFont := chosenFontNr;
				FontMenuSelection := MenuItem;
			end;
		SetItemMark(MenuList[fontMenu], FontMenuSelection, chr(checkMark));
		NewLogText(currentFont, currentSize); {in unit log}
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
	procedure changeFontSize (MenuItem: integer);

	begin
		GetPort(oldPort);
		SetPort(LogWindow);
		SetItemMark(MenuList[fontSizeMenu], sizeMenuSelection, chr(noMark));
		case MenuItem of
			Pt8: 
				CurrentSize := 8;
			Pt9: 
				CurrentSize := 9;
			Pt10: 
				CurrentSize := 10;
			Pt12: 
				CurrentSize := 12;
		end;{case}
		sizeMenuSelection := MenuItem;
		SetItemMark(MenuList[fontSizeMenu], sizeMenuSelection, chr(checkMark));
		NewLogText(currentFont, currentSize);{in unit log}
		setPort(oldPort);
	end;

{----------------------------------------------------------------------------}
end. {of unit myFonts}