unit myWindows;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                             }
{	 Version 1.2.0 - Changes programmed by B.J. Kbben:                                               }
{                              - Various beeps, 25-08-92                                                             }
{                              - improved handling of OK button, 25-08-92                                   }
{   Version 2.0 -   Changes programmed by B.J.Kbben:													}
{								- SetSetUpMessage, logs current setup, 12-92					
		Version 2.2OS - code and app made OpenSource July 2002 BJK			}
{ ########################################################}

interface
	uses
		{UIP}
			QuickDraw,memory,types,windows,fp,TextEdit,QuickDrawText,fonts,events,Dialogs,
			processes,controls,ToolUtils,menus,QDOffscreen,OSUtils    ,
		{MyUnits}
			globals, ErrorsAndBeeps, log,scale;

		
	var
		ScrScale,BalkMin,BalkMax:real;
		balk, MessageRect,DrawingRect: rect;
		LightBluePat, DarkGrayPat, DarkBluePat, WhitePat, RedPat, BackGreyPat:PixPatHandle;
		HatchAsked, CurveAsked, SplineAsked, Line3DAsked, PolygonMeshAsked,PolyFaceMeshAsked: boolean;
	
	procedure BoxOutLine(ARect:rect;thickness:integer);
	procedure InitBalk(min,max:real);
	procedure DoBalk(now:real);
	procedure SetMessage (messageNr: Integer; logIt: boolean);
	procedure SetInfoMessage (messageNr: Integer);
	procedure SetSetupMessage (messageNr: Integer; extramessage: str255);
	procedure CreateDrawingWindow(Title:str255);
	procedure RemoveDrawingWindow;
	PROCEDURE CopyToGWorld (wp: WindowPtr);
	PROCEDURE CopyFromGWorld (wp: WindowPtr);
	function ScrGetMaxX: integer;
	function ScrGetMaxY: Integer;
	procedure CheckAbort;
	procedure ShowInfo (ACADversion:str255; DxfFsize, IllFsize: integer; layers, ltypes, blocks: integer);
	function AskHatch: boolean;
	function Ask_Curve_Fit: boolean;
	function Ask_Spline_Fit: boolean;
	function Ask_3D_Line: boolean;
	function Ask_PolygonMesh: boolean;
	function Ask_PolyfaceMesh: boolean;

implementation

	const
		ButtonItem=1;
		BalkItem=2;
		MessageItem=3;
		DrawingRectItem=4;
		minMaxTxtItem = 5;
		minMaxIllTxtItem = 6;
		minMaxItem = 7;
		minMaxIllItem = 8;
		DXFsizeItem = 9;
		IllsizeItem = 10;
		LayersItem = 11;
		LTypesItem = 12;
		BlocksItem = 13;
		ArrowItem=14;
		ScalingToItem = 15;
		ACADversionItem =16;
		CmdPeriodItem=17;
		ProgressCmdPeriodItem=4;
		
	var
		LastMessageNr: integer;		
		ButtonHandle : Handle;
		ButtonRect:rect;
		GWorldInited: boolean;
		lasttime :longint;
		KeyCh: Char;
		
		
		myOffGWorld: GWorldPtr;
		
		offPixMapHandle: PixMapHandle;
	
	{------------------------------------}
		PROCEDURE MakeGWorld (wp: WindowPtr);
		
		VAR
			myErr:								QDErr;
			good:								Boolean;
			origPort:CGrafPtr;
			origDev: GDHandle;
			
			
		BEGIN
			GWorldINited := false;
			GetGWorld(origPort, origDev);													{save window's graphics port}
			myErr := NewGWorld(myOffGWorld, 0,wp^.portRect,	NIL, NIL, 0);
			IF (myOffGWorld = NIL) OR (myErr <> noErr) THEN
				begin
				Error('[MakeGWorld:1]',0,0,false,true); 
				exitToShell;
				end;
			SetGWorld(myOffGWorld, NIL);										{make offscreen world the current port}
			offPixMapHandle := GetGWorldPixMap(myOffGWorld);																	{get handle to }
			good := LockPixels(offPixMapHandle);											 { offscreen pixel image and lock it}
			IF NOT good THEN
					begin
					Error('[MakeGWorld:2]',0,0,false,true); 
					exitToShell;
					end;
			EraseRect(myOffGWorld^.portRect);														{initialize its pixel image}
			
			SetGWorld(origPort, origDev);													{make window the current port}
			
			GWorldINited := true;
		END;
	
	{------------------------------------}
	PROCEDURE CopyFromGWorld (wp: WindowPtr);
		
		VAR
			sourceRect, destRect:	Rect;
			origPort:CGrafPtr;
			origDev: GDHandle;
			
			
	BEGIN
		if GWorldInited and DrwWinInited then
			begin 
			getGWorld(origPort, origDev);
			sourceRect := myOffGWorld^.portRect;													{use offscreen portRect for source}
			destRect := wp^.portRect;											{use window portRect for destination}
			ForeColor(blackColor); BackColor(WhiteColor);		
				{next, use CopyBits to transfer the offscreen image to the window}
			CopyBits(GrafPtr(myOffGWorld)^.portBits,GrafPtr(wp)^.portBits, sourceRect, destRect, srcCopy, NIL);
			IF QDError <> noErr THEN
				begin
				Error('[CopyFromGWorld]',0,0,false,true); 
				exitToShell;
				end;			
			setGWorld(origPort, origDev);		
			end;			
	END;
	
	{------------------------------------}
	PROCEDURE CopyToGWorld (wp: WindowPtr);
		
		VAR
			sourceRect, destRect:	Rect;
			origPort:CGrafPtr;
			origDev: GDHandle;
			
			
	BEGIN
		if GWorldInited and DrwWinInited  then
			begin 
			getGWorld(origPort, origDev);
			destRect := myOffGWorld^.portRect;													
			sourceRect := wp^.portRect;	
			ForeColor(blackColor); BackColor(WhiteColor);		
				{next, use CopyBits to transfer the offscreen image to the window}
			CopyBits(GrafPtr(wp)^.portBits,GrafPtr(myOffGWorld)^.portBits, sourceRect, destRect, srcCopy, NIL);
			IF QDError <> noErr THEN
				begin
				Error('[CopyFromGWorld]',0,0,false,true); 
				exitToShell;
				end;			
			setGWorld(origPort, origDev);		
			end;			
	END;
	
	
	{------------------------------------}
	PROCEDURE RemoveGWorld;
			
			
	BEGIN
		if GWorldInited then
			begin 
			UnlockPixels(offPixMapHandle);													{unlock the pixel image}
			DisposeGWorld(myOffGWorld);			
			GWorldInited := false;	
			end
		else 
			begin
			Error('[RemoveGWorld] Cannot dispose!',0,0,false,false);  
			exitToShell;
			end;
	END;
	
	{------------------------------------}
	procedure BoxOutLine(ARect:rect;thickness:integer);
	
		var
			pnstate: PenState;
			
		begin
			GetPenState(Pnstate);
			PenSize(thickness,thickness);
			with ARect do
				begin
				PenPixPat(DarkGrayPat);
				moveTo(left,bottom);
				LineTo(left,top);
				LineTo(right,top);
				PenPixPat(WhitePat);
				LineTo(right,bottom);
				LineTo(left,bottom);
				end;			
			SetPenState(PnState);
		end;
	

{----------------------------------------}
	procedure InitBalk(min,max:real);
			
	begin
		if DrwWinInited then
			begin
			insetrect(balk, -1, -1);	
			BoxOutLine(Balk,1);
			insetrect(balk, 1, 1);	
			fillCRect(balk, LightBluePat);
			end;
		balkMin := min;
		balkMax := max;
		lasttime := 0;
	end;
	
	
{----------------------------------------}
	procedure DoBalk(now:real);
		var
			deel: real;
			fillrect: rect;
			
	begin
		if (TickCount - lasttime > 20) or (now=balkMax) then
			begin
			if DrwWinInited then
				begin
				getPort(OldPort);
				setPort(DrawWIndow);
				deel := (now - balkMin) / BalkMax;
				fillrect := balk;
				if now < BalkMax then
					fillrect.right := roundtol(deel * (fillrect.right - fillrect.left));
				FillCRect(fillrect,RedPat);
				lasttime := TickCount;
				setPort(OldPort);
				end;
			end;
	end;
		
{----------------------------------------------------------------------------}
	procedure updateDrawWindow;
	
	begin
		if DrwWinInited then
			begin
			GetPort(oldPort);
			setPort(DrawWindow);
			drawDialog(DrawWindow);	
			DrawControls(DrawWindow);	
			insetrect(balk, -1, -1);	
			BoxOutLine(Balk,1);
			insetrect(balk, 1, 1);	
			fillCRect(balk, LightBluePat);
			SetMessage(lastmessageNr,false);
			setPort(oldPort);
			end;
	end;
	
	{------------------------------------}
	procedure RemoveDrawingWindow;
	
		const 
			OKitem=1;
		var
			ThisMenu,ItemHit:integer;
			Ready:boolean;
			
	begin
		if DrwWinInited then
			begin
				Ready := false;
				for ThisMenu := FileMenu to ModeMenu do
					EnableItem(menuList[thisMenu], 0); 
				drawMenuBar;
				
				if not aborted then
					begin
					getPort(oldPort);
					SetPort(DrawWindow);
					hideDialogItem(DrawWindow, CmdPeriodItem);
					TextFont(SystemFont);
					insetRect(ButtonRect, -4, -4);
					PenSize(3, 3);
					FrameRoundRect(ButtonRect, 16, 16);
					PenSize(1, 1);
					SetCursor(QD.arrow);
					showDialogItem(DrawWindow, ButtonItem);
					SetControlTitle(ControlHandle(ButtonHandle), stringlist(OKnr));
					DrawDialog(DrawWindow);
					showcursor;
					play(ping);
					
					if autoAnswer and not InfoOnly then
						begin
						timedDialogStartTime := tickCount;
						ModalDialog(timedDialogUPP, ItemHit);
						end
					else
						ModalDialog(nil, ItemHit);
					
					
					aborted := false;
					setPort(oldPort);
					end;
								
				if not doBackground then
					RemoveGWorld;
				DisposeDialog(DrawWindow);
				
				DrwWinInited := False;
			end;
	end;
		
	{------------------------------------}
	procedure CreateDrawingWindow(title:str255);	
		
		const
			DrawWindowID=130;
			ProgressWindowID=129;
			
		var
			itemtype,ThisMenu,i: integer;
			BalkHandle, MessageHandle, DrawingRectHandle  : Handle;
			
		begin
			if not DrwWinInited then
				begin
				
				lastMessageNr := 0;
				for ThisMenu := FileMenu to ModeMenu do
					DisableItem(menuList[thisMenu], 0); 
				drawMenuBar;
				
				if  doBackground and not InfoOnly then
					DrawWindow := GetNewDialog(ProgressWindowID,nil,pointer(-1))
				else
					DrawWindow := GetNewDialog(DrawWindowID,nil,pointer(-1));
					
				setWTitle(DrawWindow,title);
				SetPort(DrawWindow);
				TextFont(SystemFont);
				for i := 	minMaxTxtItem to ACADversionItem do
					HideDialogItem(DrawWindow,i);
				getDialogItem(DrawWindow, ButtonItem, itemtype, ButtonHandle, ButtonRect);
				getDialogItem(DrawWindow, BalkItem, itemtype, BalkHandle, balk);
				insetrect(balk, 1, 1);	
				getDialogItem(DrawWindow, MessageItem, itemtype, MessageHandle, MessageRect);
				getDialogItem(DrawWindow, DrawingRectItem, itemtype, DrawingRectHandle, DrawingRect);
								
				showDialogItem(DrawWindow, CmdPeriodItem);
				hideDialogItem(DrawWindow, ButtonItem);
		
				drawDialog(DrawWindow);	
				
				DrawControls(DrawWindow);	
				
				if doBackground then
					begin
					DrwWinInited := True;
					end
				else
					begin
					MakeGWorld(DrawWindow);
					if GWorldInited then 
						begin
						DrwWinInited := True;
						end;
					end;
											
				showcursor;
				end;
		end;
	
	{------------------------------------}
	procedure SetMessage (messageNr: Integer; logIt: boolean);
		var
			message: str255;
						
	begin
		if messageNr = 0 then
			Message := ''
		else
			Message := stringlist(MessageNr);	
		if DrwWinInited then
			begin
			getPort(OldPort);
			setPort(DrawWIndow);
			with MessageRect do
				moveto(left,bottom-3);
			FillCRect(MessageRect,BackGreyPat);
			Drawstring(Message);
			setPort(OldPort);
			end;
		if LogIt then
			WriteLog(Message);
		lastmessageNr := messageNr;
	end;

	{------------------------------------}
	procedure SetInfoMessage (messageNr: Integer);
		var
			message: string;
			
	begin
		if messageNr = 0 then
			Message := ''
		else
			Message := stringlist(MessageNr);	
		if DrwWinInited then
			begin
			getPort(OldPort);
			setPort(DrawWIndow);
			with MessageRect do
				moveto(left,bottom-3);
			FillCRect(MessageRect,BackGreyPat);
			Drawstring(Message);
			setPort(OldPort);
			end;
		lastmessageNr := messageNr;
	end;

	{------------------------------------}
	procedure SetSetUpMessage (messageNr: Integer; extramessage: str255);  { only in Log}
		var
			message: str255;
	begin
		if messagenr = 0 then {omit 'SetUp:', is used for building Colour & Font List}
			Message := ExtraMessage
		else
			Message := concat(stringlist(SetUpSTrNr), stringlist(MessageNr), extramessage);
		writeLog(Message);
	end;

	{------------------------------------}
	function ScrGetMaxX: integer;
		
	var
		temp: integer;
	
	begin
	temp := abs(DrawingRect.right - DrawingRect.left);
	ScrGetMaxX := temp;
	end;

	{------------------------------------}
	function ScrGetMaxY: Integer;
		
	var
		temp: integer;
	
	begin
	temp := abs(DrawingRect.bottom - DrawingRect.top);
	ScrGetMaxY := temp;
	end;

	{------------------------------------}
	procedure CheckAbort;
	
		const
			CmdKey = 55;
			PeriodKey = 47;
		var
			theEvent:EventRecord;
			myKeyMap: KeyMap;
			
		{--------------------}
		procedure AbortProcess;
			begin							
			flushEvents(everyEvent,0);
			if not infoOnly then
				Error(stringlist(AbortedNr), 0, 0, true,false);
			Aborted := True;
			flushEvents(everyEvent,0);
			end;
		{--------------------}
				
	begin
	
		if doBackground and not infoOnly then {Slow Mode}
		
			begin
			if WaitNextEvent(EveryEvent, theEvent,1,nil) then
				begin
					case theEvent.What of
						keyDown:
							begin
							getKeys(myKeyMap);
							if myKeyMap[CmdKey] and myKeyMap[PeriodKey] then
								AbortProcess;
							end;
						UpdateEvt:
							begin
							if (windowPtr(theEvent.message) = logWindow) then
								begin
								BeginUpdate(WindowPtr(theEvent.message));
								UpdateLogWindow; {in unit log}
								EndUpdate(WindowPtr(theEvent.message));
								end
							else if (windowPtr(theEvent.message) = drawWindow) then
								begin
								BeginUpdate(WindowPtr(theEvent.message));
								UpdateDrawWindow; {in unit log}
								EndUpdate(WindowPtr(theEvent.message));
								end;
							end;
						OSEvt:
							begin
							if drwWinInited then
								begin 
								IF (BAnd(theEvent.message, resumeFlag) <> 0) THEN 
									BEGIN	{it's a resume event}
										;
									END
								else
									begin	{it's a suspend event}
										;
									end;
								end;
							end;
								
						otherwise
							;
					end;{case}
					
				end;{WaitNextEvent}
			end {dobackground}
			
		else {Foreground mode}
		
			begin
			getKeys(myKeyMap);
			if (myKeyMap[CmdKey] and myKeyMap[PeriodKey]) then
				AbortProcess;
			end;
			
	 if (EOFencountered) then
			AbortProcess;
			
	end; {procedure}
		

	
	{-----------------------------------}
	procedure ShowInfo (ACADversion:str255; DxfFsize, IllFsize: integer; layers, ltypes, blocks: integer);
		
			
		var
			TheItem, ItemType,i: Integer;
			item: Handle;
			ItemBox: rect;
			temp, temp2: str255;
			
	begin
		if DrwWinINITED THEN
			begin
			getPort(oldPort);
			setPort(Drawwindow);
			SetCursor(QD.arrow);
			BoxOutLine(DrawingRect,2);
			
			if SetUp^^.scaling = ToCustom then {custom scaling}
				begin
				temp := stringlist(ScaleToNr + byte(SetUp^^.scaling));
				temp2 := StringOf((SetUp^^.customScale * eenheid) : 1 : 5, ' ', EenheidStr);
				end
			else
				begin
				temp := stringlist(ScaleToNr + byte(SetUp^^.scaling));
			  temp2 := StringOf((illscale / points) : 1 : 5, ' mm.');
				end;

			Paramtext(temp, temp2, '', '');
			for i := 	minMaxTxtItem to ACADversionItem do
				ShowDialogItem(DrawWindow,i);
			
			showDialogItem(DrawWindow, ButtonItem);
						
			TextFont(3); {geneva}
			TextSize(12);
			
			for TheItem := DXFsizeItem to ACADversionItem do
				begin
					getDialogItem(DrawWindow, TheItem, itemtype, item, ItemBox);
					moveto(ItemBox.right + 6, itemBox.bottom - 4);
					case TheItem of
						ACADversionItem: 
							Drawstring(ACADversion);
						DXFsizeItem: 
							Drawstring(StringOf(DxfFsize : 1, ' kByte'));
						IllsizeItem: 
							Drawstring(StringOf(IllFsize : 1, ' kByte'));
						LayersItem: 
							Drawstring(StringOf(layers : 1));
						LTypesItem: 
							Drawstring(StringOf(ltypes : 1));
						BlocksItem: 
							Drawstring(StringOf(blocks : 1));
					end; {case}
				end;
				
			TextSize(9);
			getDialogItem(DrawWindow, minMaxItem, itemtype, item, ItemBox);
			if Limits.Xmin = roundtol(Limits.Xmin) then
				temp := stringOf(Limits.Xmin : 1 : 0)
			else
				temp := stringOf(Limits.Xmin : 1 : 3);
			moveto(itemBox.left - roundtol(stringWidth(temp) / 2 - 11), itemBox.bottom + 8);
			Drawstring(temp);
			if Limits.Ymin = roundtol(Limits.Ymin) then
				temp := stringOf(Limits.Ymin : 1 : 0)
			else
				temp := stringOf(Limits.Ymin : 1 : 3);
			moveto(itemBox.left - StringWidth(temp) - 1, itemBox.bottom - 10);
			Drawstring(temp);
			if Limits.Xmax = roundtol(Limits.Xmax) then
				temp := stringOf(Limits.Xmax : 1 : 0)
			else
				temp := stringOf(Limits.Xmax : 1 : 3);
			moveto(itemBox.right - roundtol(stringWidth(temp) / 2) - 11, itemBox.top - 1);
			Drawstring(temp);
			if Limits.Ymax = roundtol(Limits.Ymax) then
				temp := stringOf(Limits.Ymax : 1 : 0)
			else
				temp := stringOf(Limits.Ymax : 1 : 3);
			moveto(itemBox.right, itemBox.top + 18);
			Drawstring(temp);

			getDialogItem(DrawWindow, minMaxIllItem, itemtype, item, ItemBox);
			if Limits.IllXmin = roundtol(Limits.IllXmin) then
				temp := stringOf(Limits.IllXmin : 1 : 1)
			else
				temp := stringOf(Limits.IllXmin : 1 : 2);
			moveto(itemBox.left - roundtol(stringWidth(temp) / 2 - 11), itemBox.bottom + 8);
			Drawstring(temp);
			if Limits.IllYmin = roundtol(Limits.IllYmin) then
				temp := stringOf(Limits.IllYmin : 1 : 1)
			else
				temp := stringOf(Limits.IllYmin : 1 : 2);
			moveto(itemBox.left - StringWidth(temp) - 1, itemBox.bottom - 10);
			Drawstring(temp);
			if Limits.IllXmax = roundtol(Limits.IllXmax) then
				temp := stringOf(Limits.IllXmax : 1 : 1)
			else
				temp := stringOf(Limits.IllXmax : 1 : 2);
			moveto(itemBox.right - roundtol(stringWidth(temp) / 2) - 11, itemBox.top - 1);
			Drawstring(temp);
			if Limits.IllYmax = roundtol(Limits.IllYmax) then
				temp := stringOf(Limits.IllYmax : 1 : 1)
			else
				temp := stringOf(Limits.IllYmax : 1 : 2);
			moveto(itemBox.right, itemBox.top + 18);
			Drawstring(temp);

			TextFont(SystemFont);
			TextSize(0);
			
			DrawDialog(DrawWindow);
			doBalk(BalkMax);
			removeDrawingWindow;
			setPort(oldPort);
			Paramtext('', '', '', '');
			end
		else
			Error('DrawWindow not inited!',0,0,false,false);
		end;

{-----------------------------------}
	function AskHatch: boolean;
		var
			answer : boolean;
			DlogPtr: DialogPtr;
			TheItem: Integer;
	begin
		if not HatchAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				DlogPtr := GetNewDialog(AskHatchId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				DisposeDialog(Dlogptr);
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				HatchAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		AskHatch := answer;
	end;
		
{-------------------------------}
	function Ask_Curve_Fit: boolean;
		var
			DlogPtr: DialogPtr;
			TheItem: Integer;
			answer:boolean;
	begin
		if not CurveAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				ParamText(stringList(CurveFitNr), '', '', '');
				DlogPtr := GetNewDialog(AskSkipOrTryId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				DisposeDialog(Dlogptr);
				CurveAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		Ask_Curve_Fit := answer;
	end;

{-----------------------------------}
	function Ask_Spline_Fit: boolean;
		var
			DlogPtr: DialogPtr;
			TheItem: Integer;
			answer:boolean;
	begin
		if not SplineAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				ParamText(stringList(SplineFitNr), '.', '', '');
				DlogPtr := GetNewDialog(AskSkipOrTryId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);	
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				DisposeDialog(Dlogptr);
				SplineAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		Ask_Spline_Fit := answer;
		ParamText('','','', '');
	end;
		
{-----------------------------------}
	function Ask_3D_Line: boolean;
		var
			DlogPtr: DialogPtr;
			TheItem: Integer;
			answer:boolean;
	begin
		if not Line3DAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				ParamText(stringList(ThreeDLineNr), stringList(ChangeDXFoutNr),'', '');
				DlogPtr := GetNewDialog(AskSkipOrTryId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				DisposeDialog(Dlogptr);
				Line3DAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		Ask_3D_Line := answer;
		ParamText('','','', '');
	end;
	
	{-----------------------------------}
	function Ask_PolygonMesh: boolean;
		var
			DlogPtr: DialogPtr;
			TheItem: Integer;
			answer:boolean;
	begin
		if not PolygonMeshAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				ParamText(stringList(PolygonMeshNr), stringList(ChangeDXFoutNr),'', '');
				DlogPtr := GetNewDialog(AskSkipOrTryId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				DisposeDialog(Dlogptr);
				PolygonMeshAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		Ask_PolygonMesh := answer;
		ParamText('','','', '');
	end;
	
	{-----------------------------------}
	function Ask_PolyfaceMesh: boolean;
		var
			DlogPtr: DialogPtr;
			TheItem: Integer;
			answer:boolean;
	begin
		if not PolyfaceMeshAsked then
			begin
				getPort(oldPort);
				copyToGWorld(DrawWindow);
				SetCursor(QD.arrow);
				ParamText(stringList(PolyFaceMeshNr),stringList(ChangeDXFoutNr), '', '');
				DlogPtr := GetNewDialog(AskSkipOrTryId, nil, Pointer(-1));
				setPort(DlogPtr);
				FatOkBox(DlogPtr);
				play(Dong);
				if autoAnswer then
					begin
					timedDialogStartTime := tickCount;
					ModalDialog(timedDialogUPP, TheItem);
					end
				else
					ModalDialog(nil, TheItem);
				if theItem = 1 then 
					answer := false 
				else
					answer := true;
				DisposeDialog(Dlogptr);
				PolyfaceMeshAsked := True;
				setPort(oldPort);
				copyFromGWorld(drawWindow);
			end;
		Ask_PolyfaceMesh := answer;
		ParamText('','','', '');
	end;
	{-----------------------------------}
	
	
end.