unit SetUp;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{    Version 1.2.0   - Changes programmed by B.J. Kbben                                              }
{                               - SetUp dialog changed to include TieLines checkbox,  20-08-92    }
{                               - various beeps, 25-08-92                                                           }
{                               - Help text in text resource, 25-08-92                                        }
{    Version 2.0    - Programmed by B.J. Kbben:                               				              	}
{   							- Setup procedure moved to new unit Setup and expanded,12-92	}
{								- Scaling to paper & custom sizes, july 93									}
{   							- FontTableDialog: list of fonts for font-substitution; july 93			}
{ Version 2.1:		- Cleaned up Handle allocation checking - 3/94									}
{							- SetUp now in one Resource & Handle- 8/94										}
{							- Fill Checkboxes added; Lineweight now a checkbox - 8/94				}
{							- Showhelp Unit called - 9/94						
		Version 2.2OS - code and app made OpenSource July 2002 BJK									}
{ ########################################################}



interface
uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,QDOffscreen,
	Dialogs,Types,TextEdit,TextUtils,controls,toolutils,resources,
	{MyUnits}
	showHelp, globals, ErrorsAndBeeps, log, Scale,  myWindows, myFiles, myFonts, tables;

	var
		FSRsc, CSRsc, LSRsc, GroupRsc: Handle;
		EenhedenMenuId: integer;
		SetupDlog: DialogPtr; {must be global, is used in EditMenu}

	procedure DoSetUp;

implementation

	const
		SaveItem = 1;{items in DITL}
		DontSaveItem = 2;
		HelpItem = 3;
		SaveFileItem = 4;
		OpenFileItem = 5;
		Ill11Item = 6;
		FreehandItem = 7;
		Ill50Item = 8;
		FullGroupItem = 9;
		LayerGroupItem = 10;
		DontGroupItem = 11;
		ConvertorStampItem = 12;
		TieLinesItem = 13;
		FSItem = 14;
		EditFSItem = 15;
		CSItem = 16;
		EditCSItem = 17;
		A4TallItem = 18;
		A4TallItem2 = 19;
		A4WideItem = 20;
		A4WideItem2 = 21;
		A3TallItem = 22;
		A3TallItem2 = 23;
		A3WideItem = 24;
		A3WideItem2 = 25;
		MarginsItem = 26;
		CustomItem = 27;
		CusXItem = 28;
		EenheidItem = 29;
		DumpItem = 30; {item to put I-beam in where it's not seen}
		LSItem = 37;
		FillSolidItem = 38;
		FillCircleItem = 39;
		FillPolyItem = 40;
		VerboseLoggingItem = 42;
		GroupBlocksItem = 43;
		FormatBoxItem = 44;
		GroupBoxItem = 45;
		GraphicBoxItem = 46;
		scaleBoxItem = 47;
		OtherBoxItem = 48;

	var
		TheItem, ItemType: Integer;
		Ill11H, FreeHandH, Ill50H, ConvertorStampH, A4tallH, A4wideH, A3tallH, A3wideH, CustomH, CusX, EenheidHdl: Handle;
		FSHdl, CSHdl, LSHdl, EditFSHdl, EditCSHdl, EditLSHdl: Handle;
		FillSolidH, FillCircleH, FillPolyH,VerboseLoggingHdl,GroupBlocksHdl: Handle;
		TieLinesHdl, MarginsHdl, FullgroupHdl, LayerGroupHdl, DontGroupHdl: Handle;
		ItemBox, CusXBox, Menurect, HelpRect: rect;
		Paper: array[1..4] of record
				normRect, MargRect: rect;
				txt: str255;
			end;
		Box: array[FormatBoxItem..OtherBoxItem] of rect;
		OK: boolean;
		ItemHdl, HelpTxt: Handle; {BJK}
		tempReal: extended;
		MenuXY: point;

		tempSetup: SetUpRecord;


{------------------------------------------------------------}
	procedure dump; {Puts the I-beam into item "dump", not visible edititem in DLog}
	begin
		SelectDialogItemText(SetupDlog, DumpItem, 0, 0);
	end;

{------------------------------------------------------------}
	procedure show (customscale: extended);

	begin
		if TempSetUp.scaling = toCustom then
			begin
				SetDialogItemText(CusX, StringOf((customscale * eenheid) : 1 : 7));
			end
		else
			begin
				SetDialogItemText(CusX, StringOf(''));
			end;
	end;

{------------------------------------------------------------}
	procedure showSettings;

	begin
		case TempSetUp.TargetAppl of
			Ill11: 
				begin
					SetControlValue(ControlHandle(Ill11H), 1);
					SetControlValue(ControlHandle(FreeHandH), 0);
					SetControlValue(ControlHandle(ill50H), 0);
					HiliteControl(ControlHandle(FullgroupHdl), 0); {undim Grouping}
					HiliteControl(ControlHandle(LayerGroupHdl), 0);
				end;
			Freehand: 
				begin
					SetControlValue(ControlHandle(FreeHandH), 1);
					SetControlValue(ControlHandle(Ill11H), 0);
					SetControlValue(ControlHandle(ill50H), 0);
					HiliteControl(ControlHandle(FullgroupHdl), 0); {undim Grouping}
					HiliteControl(ControlHandle(LayerGroupHdl), 0);
				end;
			Ill50: 
				begin
					SetControlValue(ControlHandle(Ill11H), 0);
					SetControlValue(ControlHandle(FreeHandH), 0);
					SetControlValue(ControlHandle(ill50H), 1);
					HiliteControl(ControlHandle(FullgroupHdl), 255); {dim Grouping}
					HiliteControl(ControlHandle(LayerGroupHdl), 255);
					SetControlValue(ControlHandle(DontGroupHdl), 1);
					SetControlValue(ControlHandle(FullgroupHdl), 0);
					SetControlValue(ControlHandle(LayerGroupHdl), 0);
					TempSetup.Grouping := none;
				end;
			otherwise
				play(dong);
		end; {case}
		if TempSetUp.ConverterStamp then
			begin
				SetControlValue(ControlHandle(ConvertorStampH), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(ConvertorStampH), 0);
			end;
		if TempSetUp.Tielines then
			begin
				SetControlValue(ControlHandle(TieLinesHdl), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(TieLinesHdl), 0);
			end;
		if TempSetUp.FillSolid then
			begin
				SetControlValue(ControlHandle(FillSolidH), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(FillSolidH), 0);
			end;
		if TempSetUp.FillCircle then
			begin
				SetControlValue(ControlHandle(FillCircleH), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(FillCircleH), 0);
			end;
		if TempSetUp.FillPoly then
			begin
				SetControlValue(ControlHandle(FillPolyH), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(FillPolyH), 0);
			end;

		case TempSetUp.Grouping of
			full: 
				begin
					SetControlValue(ControlHandle(FullGroupHdl), 1);
					SetControlValue(ControlHandle(LayerGroupHdl), 0);
					SetControlValue(ControlHandle(DontGroupHdl), 0);
				end;
			byLayer: 
				begin
					SetControlValue(ControlHandle(FullGroupHdl), 0);
					SetControlValue(ControlHandle(LayerGroupHdl), 1);
					SetControlValue(ControlHandle(DontGroupHdl), 0);
				end;
			none: 
				begin
					SetControlValue(ControlHandle(FullGroupHdl), 0);
					SetControlValue(ControlHandle(LayerGroupHdl), 0);
					SetControlValue(ControlHandle(DontGroupHdl), 1);
				end;
			otherwise
				TempSetUp.Grouping := none;{error=>force none}
		end; {case}
		case TempSetUp.scaling of
			ToA4tall: 
				begin
					SetControlValue(ControlHandle(A4tallH), 1);
					SetControlValue(ControlHandle(A4wideH), 0);
					SetControlValue(ControlHandle(A3wideH), 0);
					SetControlValue(ControlHandle(A3tallH), 0);
					SetControlValue(ControlHandle(customH), 0);
					Show(0);
					dump;
					HiliteControl(ControlHandle(MarginsHdl), 0); {undim UseMargins}
				end;
			ToA4wide: 
				begin
					SetControlValue(ControlHandle(A4tallH), 0);
					SetControlValue(ControlHandle(A4wideH), 1);
					SetControlValue(ControlHandle(A3wideH), 0);
					SetControlValue(ControlHandle(A3tallH), 0);
					SetControlValue(ControlHandle(customH), 0);
					Show(0);
					dump;
					HiliteControl(ControlHandle(MarginsHdl), 0); {undim UseMargins}
				end;
			ToA3tall: 
				begin
					SetControlValue(ControlHandle(A4tallH), 0);
					SetControlValue(ControlHandle(A4wideH), 0);
					SetControlValue(ControlHandle(A3wideH), 0);
					SetControlValue(ControlHandle(A3tallH), 1);
					SetControlValue(ControlHandle(customH), 0);
					Show(0);
					dump;
					HiliteControl(ControlHandle(MarginsHdl), 0); {undim UseMargins}
				end;
			ToA3wide: 
				begin
					SetControlValue(ControlHandle(A4tallH), 0);
					SetControlValue(ControlHandle(A4wideH), 0);
					SetControlValue(ControlHandle(A3wideH), 1);
					SetControlValue(ControlHandle(A3tallH), 0);
					SetControlValue(ControlHandle(customH), 0);
					Show(0);
					dump;
					HiliteControl(ControlHandle(MarginsHdl), 0); {undim UseMargins}
				end;
			ToCustom: 
				begin
					SetControlValue(ControlHandle(A4tallH), 0);
					SetControlValue(ControlHandle(A4wideH), 0);
					SetControlValue(ControlHandle(A3wideH), 0);
					SetControlValue(ControlHandle(A3tallH), 0);
					SetControlValue(ControlHandle(customH), 1);
					SetControlValue(ControlHandle(MarginsHdl), 0);
					HiliteControl(ControlHandle(MarginsHdl), 255); {dim UseMargins}
					TempSetUp.useMargins := false;
				end;
		end; {case}

		if TempSetUp.useMargins then
			SetControlValue(ControlHandle(MarginsHdl), 1)
		else
			SetControlValue(ControlHandle(MarginsHdl), 0);

		if TempSetUp.FontSubstitution then
			begin
				SetControlValue(ControlHandle(FSHdl), 1);
				HiliteControl(ControlHandle(EditFSHdl), 0); {undim button}
			end
		else
			begin
				SetControlValue(ControlHandle(FSHdl), 0);
				HiliteControl(ControlHandle(EditFSHdl), 255); {dim button}
			end;
		if TempSetUp.ColorSubstitution then
			begin
				SetControlValue(ControlHandle(CSHdl), 1);
				HiliteControl(ControlHandle(EditCSHdl), 0); {undim button}
			end
		else
			begin
				SetControlValue(ControlHandle(CSHdl), 0);
				HiliteControl(ControlHandle(EditCSHdl), 255); {dim button}
			end;
		if TempSetUp.LineweightSubstitution then
			begin
				SetControlValue(ControlHandle(LSHdl), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(LSHdl), 0);
			end;
		if TempSetUp.VerboseLogging then {2.2}
			begin
				SetControlValue(ControlHandle(VerboseLoggingHdl), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(VerboseLoggingHdl), 0);
			end;
		if TempSetUp.groupBlocks then {2.2}
			begin
				SetControlValue(ControlHandle(groupBlocksHdl), 1);
			end
		else
			begin
				SetControlValue(ControlHandle(groupBlocksHdl), 0);
			end;
	end;

{------------------------------------------------------------}
	procedure DrawDlogThings; { pop-up box and papers}
		var
			i: byte;
	begin
		GetPort(oldPort);
		setPort(SetupDlog);
		TextFont(0);
		TextSize(0);
		DrawPopUp(menurect, eenheidStr);
		showSettings;
		TextFont(Geneva);
		TextSize(9);
		for i := 1 to 4 do
			begin
				with paper[i] do
					begin
						Framerect(normrect);
						if TempSetUp.useMargins then
							PenPat(QD.gray)
						else
							PenPat(QD.white);
						Framerect(margrect);
						PenPat(QD.black);
						moveto(normrect.left + roundtol((normrect.right - normrect.left) / 2 - stringwidth(txt) / 2), normrect.top + roundtol((normrect.bottom - normrect.top) / 2) + 3);
						drawstring(txt);
					end;
			end;
		for i := FormatBoxItem to OtherBoxItem do
			BoxOutLine(Box[i],1);
		BoxOutLine(HelpRect,1);
		TextFont(0);
		TextSize(0);
		setPort(oldPort);
	end;

{------------------------------------------------------------}
	procedure DoEenhedenPopup;
		var
			MenuSelection: longint;
	begin
		GetPort(oldPort);
		setPort(SetupDlog);
		MenuXY := MenuRect.topleft;
		LocalToGlobal(menuXY);  {to make sure PopUp's on right place }
		insertMenu(MenuList[eenhedenMenu], -1); {popup eenheden}
		if TempSetUp.scaling = toCustom then
			begin
				GetDialogItemText(CusX, CusXStr);
				ReadString(CusXStr, CustomX);
				CustomX := CustomX / eenheid; {convert to mm}
			end;
		MenuSelection := PopUpMenuSelect(Menulist[EenhedenMenu], MenuXY.v, MenuXY.h, 2);
		MenuSelection := loWord(MenuSelection);
		case MenuSelection of
			1: 
				begin
					eenheidStr := 'points';
					eenheid := points;
				end;
			2: 
				begin
					eenheidStr := 'mm';
					eenheid := mm;
				end;
			3: 
				begin
					eenheidStr := 'inch';
					eenheid := inch;
				end;
		end; {case}
		show(CustomX);
		if TempSetUp.scaling = toCustom then
			SelectDialogItemText(SetupDlog, CusXItem, 0, 32767);
		DrawDlogThings;
		DeleteMenu(EenhedenMenuID);
		setPort(oldPort);
	end;

{------------------------------------------------------------}
	procedure handleEvents;

		const
			SetUpHelpID = 1500;
		var
			resErr, fileNo: integer;

	begin
		OK := false;

		 SetShowHelp(SetUpHelpID, geneva, 9, teJustLeft, HelpRect);
		 repeat
			 	begin
				ModalDialog(showhelpUPP, TheItem); {pre-UPP: ModalDialog(showHelpPtr, TheItem);}
				case TheItem of

				Ill11Item: {Illustrator radio button }
					TempSetUp.TargetAppl := Ill11;

				FreehandItem:  { FreeHand radio button }
					TempSetUp.TargetAppl := Freehand;

				Ill50Item: {Illustrator radio button }
					TempSetUp.TargetAppl := Ill50;

				ConvertorStampItem:  { log Checkbox }
					if TempSetUp.ConverterStamp then
						TempSetUp.ConverterStamp := False
					else
						TempSetUp.ConverterStamp := True;

				TieLinesItem:  { TieLines Checkbox  ***** BJK}
					if TempSetUp.TieLines then
						TempSetUp.TieLines := false
					else
						TempSetUp.TieLines := True;

				FillSolidItem: 
					if TempSetUp.FillSolid then
						TempSetUp.FillSolid := false
					else
						TempSetUp.FillSolid := true;

				FillCircleItem: 
					if TempSetUp.FillCircle then
						TempSetUp.FillCircle := false
					else
						TempSetUp.FillCircle := true;

				FillPolyItem: 
					if TempSetUp.FillPoly then
						TempSetUp.FillPoly := false
					else
						TempSetUp.FillPoly := true;

				A4tallItem, A4tallItem2:  {***** BJK}
					TempSetUp.Scaling := ToA4tall; {scaling defined in unit Scale}
				A4wideItem, A4wideItem2: 
					TempSetUp.Scaling := ToA4wide; {scaling defined in unit Scale}
				A3tallItem, A3tallItem2: 
					TempSetUp.Scaling := ToA3tall; {scaling defined in unit Scale}
				A3wideItem, A3wideItem2: 
					TempSetUp.Scaling := ToA3wide; {scaling defined in unit Scale}
				CustomItem, CusXItem: 
					begin
						if TempSetUp.scaling <> ToCustom then {to avoid re-selecting when typing in items}
							begin
								TempSetUp.Scaling := ToCustom; {scaling defined in unit Scale}
								TempSetUp.useMargins := false;
								CustomX := TempSetUp.CustomScale;
								SelectDialogItemText(SetupDlog, CusXItem, 0, 32767); {select all text in X}
								drawDlogThings; {to redraw papers}
							end;
					end;

				MarginsItem: 
					if TempSetUp.useMargins then
						begin
							TempSetUp.useMargins := False;
							{drawDlogThings;} {to redraw papers}
						end
					else
						begin
							TempSetUp.useMargins := True;
							drawDlogThings; {to redraw papers}
						end;

				EenheidItem: {pop-up box for Eenheden pressed}
					DoEenhedenPopup;

				FullGroupItem:  {***** BJK}
					TempSetUp.Grouping := full;
				LayerGroupItem: 
					TempSetUp.Grouping := byLayer;
				DontGroupItem: 
					TempSetUp.Grouping := none;

				FSItem: {FS checkbox}
					if TempSetUp.FontSubstitution then
						TempSetUp.FontSubstitution := false
					else
						TempSetUp.FontSubstitution := true;

				EditFSItem: {edit Font Table button pressed}
					begin
						tempTable := TempSetup.FontTable;
						TempSetup.FontTable := DoTable(FontT, tempTable); {in unit tables}
						SetShowHelp(SetUpHelpID, geneva, 9, teJustLeft, HelpRect); {reset, because doTables has used it}
						theItem := 0;
						drawDlogThings;
					end;

				CSItem: {CS checkbox}
					if TempSetUp.ColorSubstitution then
						TempSetUp.ColorSubstitution := false
					else
						TempSetUp.ColorSubstitution := true;

				EditCSItem: {edit Colour Table button pressed}
					begin
						tempTable := TempSetup.ColorTable;
						TempSetup.ColorTable := DoTable(ColorT, tempTable); {in unit tables}
						SetShowHelp(SetUpHelpID, geneva, 9, teJustLeft, HelpRect); {reset, because doTables has used it}
						theItem := 0;
						drawDlogThings;
					end;

				LSItem: {LS checkbox}
					if TempSetUp.lineweightSubstitution then
						TempSetUp.lineweightSubstitution := false
					else
						TempSetUp.lineweightSubstitution := true;
					
				VerboseLoggingItem: {2.2 VerboseLogging checkbox}
					if TempSetUp.VerboseLogging then
						TempSetUp.VerboseLogging := false
					else
						TempSetUp.VerboseLogging := true;
						
				GroupBlocksItem: {2.2 VerboseLogging checkbox}
					if TempSetUp.GroupBlocks then
						TempSetUp.GroupBlocks := false
					else
						TempSetUp.GroupBlocks := true;
					

				OpenFileItem: 
					begin
						fileNo := itsSTUP; {to tell open_interactive to look for 'STUP' files only}
						if open_interactive(fileno,nil) then
							begin
							if readSetupFile(fileno, tempSetup)  then
								CloseFile(fileno)
							else
								begin
									error(stringList(SetupIOErrNr), 0, 0, false,false);
									theItem := DontSaveItem; {to force leave, else corrupted Setup could get saved}
								end;
							end;
						drawDlogThings;
					end;

				SaveFileItem: 
					begin
						if create_interactive(fileno, stringList(SaveSetupAsNr), itsSTUP,nil) then
							if writeSetupFile(fileno, tempSetup) then
								CloseFile(fileno)
							else
								error(stringList(SetupIOErrNr), 0, 0, false,false);
						drawDlogThings;
					end;

				DontSaveItem, SaveItem: 
					; {=Cancel or Ok, do nothing here: handled when leaving ModalDialog}

				otherwise
					play(dong);
			end; {case}
			showsettings;
			end;

		until (TheItem = DontSaveItem) or (TheItem = SaveItem);

		if (theItem = SaveItem) then
			begin
				if TempSetUp.scaling = ToCustom then {check and convert X}
					begin
						GetDialogItemText(CusX, CusXStr);
						ReadString(CusXStr, tempReal);
						if tempReal > 0 then
							begin
								CustomX := tempReal / eenheid; {convert to  points}
								OK := true;
								TempSetUp.CustomScale := CustomX;
							end
						else
							begin
								OK := false;
								Error(stringlist(ScaleErrorNr), 0, 0, false,false);
								DrawDlogThings;
								SetCursor(QD.arrow);
							end;
					end
				else
					OK := true; {no checking required}
							
				Setup^^ := tempSetup; {save changes by putting it here}
				HNoPurge(Handle(SetUpResource));
				SetUpResource^^ := Setup^^;
				ChangedResource(Handle(SetUpResource));
				resErr := ResError;
				if resErr <> 0 then
					error(stringOf(stringlist(ResCorruptNr), chr(13), 'Cant change Setup resource. [ResError=', resErr : 1, ']'), 0, 0, false,false)
				else
					begin
						writeResource(Handle(SetUpResource));
						resErr := ResError;
						if resErr <> 0 then
							error(stringOf(stringlist(ResCorruptNr), chr(13), 'Cant write Setup resource. [ResError=', resErr : 1, ']'), 0, 0, false,false);
					end;
				HPurge(Handle(SetUpResource));
			end
		else {'cancel' button pressed}
			OK := true; {no checking required}
	end; {handleEvents}
{------------------------------------------------------------}

	procedure DoSetUp;

		var
			i: byte;

	begin
		tempSetUp := SetUp^^;
		OK := false;
		SetCursor(QD.arrow);
		paramText(version, '', '', '');
		SetupDlog := GetNewDialog(SetUpId, nil, Pointer(-1));
		SetPort(SetupDlog);
		ClipRect(SetupDlog^.PortRect); {set the ClipRgn to the dialog window}
		TextFont(SystemFont);
		getDialogItem(SetupDlog, Ill11Item, itemtype, Ill11H, ItemBox);
		getDialogItem(SetupDlog, FreehandItem, itemtype, FreeHandH, ItemBox);
		getDialogItem(SetupDlog, Ill50Item, itemtype, Ill50H, ItemBox);
		getDialogItem(SetupDlog, ConvertorStampItem, itemtype, ConvertorStampH, ItemBox);
		getDialogItem(SetupDlog, TieLinesItem, itemtype, TieLinesHdl, ItemBox);
		getDialogItem(SetupDlog, FillSolidItem, itemtype, FillSolidH, ItemBox);
		getDialogItem(SetupDlog, FillCircleItem, itemtype, FillCircleH, ItemBox);
		getDialogItem(SetupDlog, FillPolyItem, itemtype, FillPolyH, ItemBox);
		getDialogItem(SetupDlog, A4tallItem, itemtype, A4tallH, ItemBox);
		getDialogItem(SetupDlog, A4wideItem, itemtype, A4wideH, ItemBox);
		getDialogItem(SetupDlog, A3tallItem, itemtype, A3tallH, ItemBox);
		getDialogItem(SetupDlog, A3wideItem, itemtype, A3wideH, ItemBox);
		getDialogItem(SetupDlog, A4tallItem2, itemtype, CustomH, Paper[1].normRect);  {only use to get Rects}
		paper[1].txt := 'A4';
		getDialogItem(SetupDlog, A4wideItem2, itemtype, CustomH, Paper[2].normRect); {dump handle in Custom}
		paper[2].txt := 'A4';
		getDialogItem(SetupDlog, A3tallItem2, itemtype, CustomH, Paper[3].normRect);
		paper[3].txt := 'A3';
		getDialogItem(SetupDlog, A3wideItem2, itemtype, CustomH, Paper[4].normRect);
		paper[4].txt := 'A3';
		for i := 1 to 4 do
			begin
				insetRect(paper[i].normrect, -3, -3);
				paper[i].margRect := paper[i].normRect;
				insetRect(paper[i].margrect, 2, 2);
			end;
		getDialogItem(SetupDlog, CustomItem, itemtype, CustomH, ItemBox);  {now get real handle for custom.}
		getDialogItem(SetupDlog, CusXItem, itemtype, CusX, CusXBox);
		getDialogItem(SetupDlog, eenheidItem, itemtype, eenheidHdl, MenuRect);
		getDialogItem(SetupDlog, MarginsItem, itemtype, MarginsHdl, ItemBox);
		getDialogItem(SetupDlog, FSItem, itemtype, FSHdl, ItemBox);
		getDialogItem(SetupDlog, EditFSItem, itemtype, EditFSHdl, itemBox);
		getDialogItem(SetupDlog, CSItem, itemtype, CSHdl, ItemBox);
		getDialogItem(SetupDlog, EditCSItem, itemtype, EditCSHdl, itemBox);
		getDialogItem(SetupDlog, LSItem, itemtype, LSHdl, ItemBox);
		getDialogItem(SetupDlog, HelpItem, itemtype, ItemHdl, HelpRect);
		getDialogItem(SetupDlog, FullGroupItem, itemtype, FullGroupHdl, itemBox);
		getDialogItem(SetupDlog, LayerGroupItem, itemtype, LayerGroupHdl, itemBox);
		getDialogItem(SetupDlog, DontGroupItem, itemtype, DontGroupHdl, itemBox);
		getDialogItem(SetupDlog, VerboseLoggingItem, itemtype, VerboseLoggingHdl, itemBox);
		getDialogItem(SetupDlog, groupBlocksItem, itemtype, groupBlocksHdl, itemBox);
		for i := FormatBoxItem to OtherBoxItem do
			getDialogItem(SetupDlog, i, itemtype, ItemHdl, Box[i]);

		Eenheid := mm;
		eenheidStr := ' mm';
		ShowWindow(SetupDlog);
		SetPort(SetupDlog);
		setWTitle(SetupDlog, stringlist(ConversionSetupNr));
		InsetRect(MenuRect, -2, -2);
		DrawDlogThings;
		CustomX := TempSetUp.CustomScale;
		Show(customX);
		SelectDialogItemText(SetupDlog, CusXItem, 0, 32767); {select all text in X}
		
	
		while not OK do
			HandleEvents;
		DisposeDialog(SetupDlog);
		
	end;

end. {of unit Setup}