unit Tables;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC }
{    Version 2.1    Programmed by B.J. Kbben:                               				        	    }
{   						- moved from Setup unit & included Color- and LW tables - 3/94		}
{							- Table introduced; DoTable is now a function - 8/94							}
{   						- ShowHelp called in unit ShowHelp -9/94		
		Version 2.2OS - code and app made OpenSource July 2002 BJK									}
{ ########################################################}



interface
	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,events,menus,toolutils,QDOffscreen,
	Dialogs,Types,TextEdit,TextUtils,Processes,files,standardfile, Controls,ColorPicker,
		{MyUnits}
		 showHelp, globals, ErrorsAndBeeps, log, myWindows, Myfiles, Myfonts,info;
		
	type
		whichTable = (FontT, ColorT);

	var
		FontsInMenu: integer;
		TableDlog: DialogPtr; {must be global, is used in EditMenu}
		tempTable: TableType;  

	procedure DrawPopup (PopRect: rect; MenuStr: str255); {idem}
	function DoTable (which: whichTable; TheTable: TableType): TableType;	{called in Setup}

implementation


	

	const
		FullColor = 65535;
		OKitem = 1;
		CancelItem = 2;
		HelpItem = 3;
		ClearListItem = 4;
		PopUpItem = 5;
		IllThingsItem = 6;
		IllThingsTitleItem = 7;
		GetDXFItem = 8;
		DXFlistBase = 12 - 1;  {first item -1 to form a base}
		IllListBase = 32 - 1;
		LoadedCursorID = 5000;

	var
		IllThings, itemH: Handle;
		IllList, DxfList: array[1..maxNumFonts] of Handle;
		TableFileno: integer;
		TheItem, itemType: integer;
		temp, temp2: str255;
		Menurect, IllBox, itemBox, HelpRect: rect;
		OK: boolean;
		MenuXY: point;
		CurrentMacfont, CurrentPSthing: str32;
		CurrentMacColor: RGBColor;


	
{------------------------------------------------------------}
	procedure replaceItemName (itemNr: integer; Name: str255);
		var
			Title: str255;
	begin
		getDialogItem(TableDlog, itemNr, itemType, itemH, itemBox);
		GetControlTitle(ControlHandle(itemH), Title);
		insert(Name, Title, pos('^', Title));
		delete(Title, pos('^', Title), 2);
		SetControlTitle(ControlHandle(itemH), Title);
	end;
{------------------------------------------------------------}
	procedure ScreenToLists;
		var
			i: integer;
	begin
		GetPort(oldPort);
		setPort(TableDlog);
		for i := 1 to maxnumFonts do
			begin
				GetDialogItemText(DXFList[i], temp);
				GetDialogItemText(IllList[i], temp2);
				tempTable[i] := concat(temp, '\', temp2);
			end; {for i=...}
		setPort(oldPort);
	end;

{------------------------------------------------------------}
	procedure ListsToScreen;
		var
			i, LP: integer;
	begin
		GetPort(oldPort);
		setPort(TableDlog);
		for i := 1 to maxnumFonts do
			begin
				temp := tempTable[i];
				LP := pos('\', temp);
				if LP <> 0 then
					begin
						SetDialogItemText(DXFList[i], (copy(temp, 1, LP - 1)));
						SetDialogItemText(IllList[i], (copy(temp, LP + 1, length(temp) - LP)));
					end;
			end; {for i=...}
		setPort(oldPort);
	end;

{------------------------------------------------------------}
	procedure DrawPopup (PopRect: rect; MenuStr: str255);
		const
			MoreChar = '';
		var
			triangle: PolyHandle;
			i, Max: integer;
			PenNow: point;
			ready: boolean;
	begin
		PenSize(1, 1);
		EraseRect(PopRect);
		FrameRect(PopRect);
		MoveTo(PopRect.left + 1, PopRect.bottom);
		LineTo(PopRect.right, PopRect.bottom);
		LineTo(PopRect.right, PopRect.top + 1);
		MoveTo(PopRect.left + 5, PopRect.top + 13);
		if menuStr <> '' then
			begin
				Max := PopRect.right - 18 - CharWidth(moreChar); {just left of triangle}
				ready := false;
				i := 1;
				repeat
					drawChar(MenuStr[i]);
					GetPen(PenNow);
					if i = length(menuStr) then
						ready := true
					else if (PenNow.h > Max) then
						begin
							ready := true;
							drawChar(moreChar);
						end;
					i := i + 1;
				until ready;
			end;
		moveto(PopRect.right - 17, roundtol(PopRect.top + (PopRect.bottom - PopRect.top) / 2) - 3);
		triangle := OpenPoly;
		line(13, 0);
		line(-6, 7);
		line(-6, -7);
		closePoly;
		FillPoly(triangle, QD.black);
		killPoly(triangle);
	end;

{--------------------------}
	procedure drawTableThings (which: whichTable);

	begin
		GetPort(oldPort);
		setPort(TableDlog);
		case which of
			FontT: 
				begin
					temp := stringList(FontNr);
					temp2 := '(Postscript)';
				end;
			ColorT: 
				begin
					temp := stringList(ColorNr);
					temp2 := '(CMYK)';
				end;
		end;{case}
		ParamText(version, '', temp2, temp);
		FatOkBox(TableDlog);
		if which = FontT then
			DrawPopUp(IllBox, CurrentMacfont);
		BoxOutLine(HelpRect,1);
		setPort(oldPort);
	end;

{-----------------------------------------------}
	procedure GetDXFThings (which: whichTable);

	begin
		setCursor(QD.arrow);
		CurrentPSThing := '';
		numTableThings := 1;
		case which of
			FontT: 
				collectInfo(getFonts);
			ColorT: 
				collectInfo(getColors);
			otherwise
				;
		end;{case}
		ListsToScreen;
		drawTableThings(which);
		setPort(TableDlog);
	end;

{-----------------------------------------}
	function checkPSColor (var ColorStr: str255): boolean;

		var
			C, M, Y, K: real;

	begin
		C := -1;
		M := -1;
		Y := -1;
		K := -1;
		readString(ColorStr, C, M, Y, K);
		if (C < 0) or (C > 1) or (M < 0) or (M > 1) or (Y < 0) or (Y > 1) or (K < 0) or (K > 1) then
			checkPSColor := false
		else
			checkPSColor := true;
		ColorStr := stringOf(C : 3 : 2, ' ', M : 3 : 2, ' ', Y : 3 : 2, ' ', K : 3 : 2);
	end;

{-----------------------------------------}
	function checkPSLineweight (var LWStr: str255): boolean;

		var
			W: real;
			i: byte;
			E: str255;
			letterFound: char;

	begin
		letterfound := ' '; {points if no eenheid specified}
		W := -1;
		readString(LWStr, W, E);
		for i := 1 to length(E) do
			begin
				if E[i] <> chr(32) then {space}
					begin
						letterfound := E[i];
						Leave;
					end;
			end;
		if (LetterFound = 'p') or (LetterFound = 'P') then
			E := ''
		else if (LetterFound = 'm') or (LetterFound = 'M') then
			E := 'mm.'
		else if (LetterFound = 'i') or (LetterFound = 'I') then
			E := 'inch'
		else {no eenheid -> points}
			E := '';
		if (W < 0.001) and (W > 0) then
			begin
				checkPSLIneweight := true;
				W := 0.001;  {truncate to smallest allowed}
			end
		else if (W <= 0) then
			checkPSLineweight := false
		else
			checkPSLineweight := true;
		LWStr := stringOf(W : 5 : 3, ' ', E);
	end;

{-----------------------------------------}
	function GetPSColor: Str255;

		const
			K = 0.0;
		var
			newColor: RGBcolor;
			PSColor: CMYColor;
			C, M, Y: real;
			where: point;

	begin
		where.h := 0;
		where.v := 0; {where = 0,0 => centered on screen}
		if (GetColor(where, stringList(RGBcolorNr), currentMacColor, newColor)) then
			currentMacColor := newColor;
		
		RGB2CMY(currentMacColor, PSColor);
		C := (SmallFract2Fix(PSColor.cyan) / FullColor);
		M := (SmallFract2Fix(PSColor.magenta) / FullColor);
		Y := (SmallFract2Fix(PSColor.yellow) / FullColor);
		GetPSColor := stringOf(C : 5 : 2, ' ', M : 5 : 2, ' ', Y : 5 : 2, ' ', K : 5 : 2);
		setCursor(getcursor(LoadedCursorID)^^);
	end;

{------------------------------------------------------------}
	function checkThings (which: whichTable): boolean;

		var
			lastWrongOne, i: integer;

	begin
		lastWrongOne := 0;
		for i := 1 to maxnumFonts do
			begin
				GetDialogItemText(DXFList[i], temp);
				GetDialogItemText(IllList[i], temp2);
				if not (temp = '') then {no DXFitem -> don't use}
					case which of
						FontT: 
							if (Pos(' ', temp2) <> 0) or (temp2 = '') then
								lastWrongOne := i;
						ColorT: 
							if not checkPSColor(temp2) then
								lastWrongOne := i;
						otherwise
							;
					end; {case}
				SetDialogItemText(IllList[i], temp2); {put checked & standardized text in list}
			end;{for i =...}
		if lastWrongOne = 0 then {all OK}
			checkThings := true
		else
			begin
				checkThings := false;
				Error(stringList(InvalidStringNr), 0, 0, false,false);
				SelectDialogItemText(TableDlog, IllListBase + lastWrongOne, 0, 32767);
			end;
	end; {procedure checkthings}

{------------------------------------------}
	function GetPSfont: Str255;

		var
			MenuSelection: longint;
			FontXY: point;
			chosenFont: str255;
			chosenFontNr: integer;

	begin
		FontXY := IllBox.topleft;
		LocalToGlobal(FontXY);
		SetItemMark(MenuList[fontMenu], FontMenuSelection, chr(noMark)); {remove checkmark used by Log}
		MenuSelection := PopUpMenuSelect(Menulist[FontMenu], FontXY.v, FontXY.h, 1);
		if MenuSelection <> 0 then
			begin
				MenuSelection := loWord(MenuSelection);
				GetMenuItemText(menuList[FontMenu], MenuSelection, ChosenFont);
				GetFnum(ChosenFont, chosenFontNr);
				CurrentMacFont := ChosenFont;
				temp := PSName(ChosenFontNr); {extracts PostScript names, in unit font}
				if temp = 'NotPS' then
					begin
						CurrentMacfont := '';
						CurrentPSthing := '';
						setCursor(QD.arrow);
						GetPSfont := '';
					end
				else
					begin
						setCursor(getcursor(LoadedCursorID)^^);
						CurrentMacFont := ChosenFont;
						GetPSfont := temp;
					end;
			end;
		SetItemMark(MenuList[fontMenu], FontMenuSelection, chr(checkMark)); {reset checkmark used by Log}
	end;

{-------------------------------------------}
	procedure HandleTableThings (which: whichTable);

		
		var
			i: byte;

	begin
		repeat
		
			ModalDialog(showHelpUPP, TheItem);{Pre-UPP: ModalDialog(@ModalShowHelp, TheItem);}

			if TheItem = GetDXFItem then
				begin
					CurrentMacfont := '';
					CurrentPSthing := '';
					GetDXFThings(which);
					drawTableThings(which);
				end

			else if (TheItem = IllThingsItem) or (theItem = popupItem) then
				begin
					case which of
						FontT: 
							CurrentPSthing := GetPSfont;
						ColorT: 
							CurrentPSthing := GetPSColor;
						otherwise {should not happen}
							play(dong);
					end;{case}
					drawTableThings(which);
				end

			else if TheItem = ClearListItem then
				begin
					for i := 1 to maxnumFonts do
						begin
							SetDialogItemText(DXFList[i], ''); {just clear screen list, OK clears real font list}
							SetDialogItemText(IllList[i], '');
						end;
					case which of
						FontT: 
							CurrentMacfont := '';
						ColorT: 
							begin
								CurrentMacColor.red := fullColor;
								CurrentMacColor.green := fullColor;
								CurrentMacColor.blue := fullColor; {makes black}
							end;
						otherwise
							;
					end;{case}
					CurrentPSthing := '';
					setCursor(QD.arrow);
					drawTableThings(which);
				end

			else if (TheItem > DXFlistBase) and (TheItem <= IllListBase) then
				begin
					CurrentPSthing := '';
					SetCursor(QD.arrow);
					drawTableThings(which);
				end

			else if (TheItem > IllListBase) then
				begin
					if (CurrentPSthing <> '') then
						begin
							SetDialogItemText(IllList[TheItem - IllListBase], CurrentPSthing);
						end;
				end

			else if theItem = OKItem then
				begin
					if not CheckThings(which) then
						theItem := HelpItem; {just a temporary dump to force back to modaldialog}
					drawTableThings(which);
				end;

		until (TheItem = OKItem) or (Theitem = CancelItem);

	end;

{------------------------------------------------------------}
	function DoTable (which: whichTable; TheTable: TableType): TableType;

	const
			FontTableHelpID = 1510;
			ColorTableHelpID = 1511;
		var
			i: byte;
			HelpID: integer;

	begin
		GetPort(oldPort);
		TableDlog := GetNewDialog(TableID, nil, Pointer(-1));
		SetPort(TableDlog);
		tempTable := TheTable;
		case which of
			FontT: 
				begin
					temp := stringList(FontNr);
					temp2 := '(Postscript)';
					HelpID := FontTableHelpID;
				end;
			ColorT: 
				begin
					temp := stringList(ColorNr);
					temp2 := '(CMYK)';
					HelpID := ColorTableHelpID;
				end;
			otherwise
				;
		end;{case}	
		ParamText(version, '', temp2, temp);
		replaceItemName(GetDXFItem, temp);
		replaceItemName(ClearListItem, temp);
		getDialogItem(TableDlog, IllThingsItem, itemType, IllThings, IllBox);
		case which of
			fontT: 
				begin
					HideDialogItem(TableDlog, IllThingsItem); {hide the button}
					getDialogItem(TableDlog, PopUpItem, itemType, IllThings, IllBox);
				end;
			ColorT: 
				begin
					HideDialogItem(TableDlog, IllThingsTitleItem); {hide pop-up title}
					replaceItemName(IllThingsItem, temp);
				end;
			otherwise
				;
		end; {case}
		for i := 1 to maxNumFonts do
			begin
				getDialogItem(TableDlog, IllListBase + i, itemtype, IllList[i], ItemBox);
				getDialogItem(TableDlog, DXFListBase + i, itemtype, DXFList[i], ItemBox);
			end;
		getDialogItem(TableDlog, HelpItem, itemType, ItemH, HelpRect);
		ShowWindow(TableDlog);
		CurrentMacfont := '';
		CurrentPSthing := '';
		CurrentMacColor.red := FullColor; {set current color r=g=b=maxInt => white}
		CurrentMacColor.green := FullColor;
		CurrentMacColor.blue := FullColor;
		drawTableThings(which);
		ListsToscreen;
		SetShowHelp(HelpID, geneva, 9, teJustLeft, HelpRect);
		

		HandleTableThings(which); {keeps looping till OK or Cancel}

		if TheItem = CancelItem then
			begin
				doTable := TheTable; {nothing changes}
			end
		else {OKItem pressed, get screen lists into arrays}
			begin
				screenToLists;
				case which of
					FontT: 
						DoTable := tempTable;
					ColorT: 
						DoTable := tempTable;
					otherwise
						;
				end; {case}
			end;

		DisposeDialog(TableDlog);
		TextFont(SystemFont);
		TextSize(0);
		setCursor(QD.arrow);
		CurrentPSThing := '';
		setPort(oldPort);
	end;
	

{-------------------------------------------}
end. {of unit Tables}